﻿using System;
using System.Collections;
using UnityEngine;
#pragma warning disable IDE0051 // Remove unused private members
namespace Mod
{

    public struct Assets
    {
        public static Sprite XLSbullet;
        public static Sprite RocketLaunch;
        public static Sprite subMine;
        public static Sprite bubble1;
        public static Sprite bubble2;
        public static Sprite bubble3;
        public static Sprite bubble4;
        public static Sprite HyperShot;
        public static Sprite blackholeCircle;
        public static Sprite scatterBlast;
        public static Sprite rm_Mine;
        public static Sprite guitarNote;
        public static AudioClip mineNoise;
        public static AudioClip remoteNoise;
        public static AudioClip projHit;
        public static AudioClip rocketFly;
        public static AudioClip HyperlaserHit;
        public static AudioClip JBTaserSound;
        //explosions
        public static AudioClip Explosion;
        public static AudioClip R80Explosion;
        public static AudioClip SubspaceExplosion;
        public static AudioClip RemoteExplosion;


        public static Vector3 zColor;

    }
    public class Mod : MonoBehaviour
    {
        public static string ModTag = " [ROBLOX]";
        public static string order = "ROBLOX"; //so that way all the stuff is next to eachother, but isnt at the very front or in its own special little category
        public static string order2 = "ROBLOXIAN"; //having humans inbetween items sounds annoying af
        public static Material colorableMaterial = ModAPI.FindSpawnable("Human").Prefab.transform.Find("Head").GetComponent<SpriteRenderer>().material;
        public static void Main()
        {
            #region loadassets
            Assets.XLSbullet = ModAPI.LoadSprite("sprites/xlsbullet.png");
            Assets.RocketLaunch = ModAPI.LoadSprite("sprites/rocketlaunch.png");
            Assets.bubble1 = ModAPI.LoadSprite("sprites/whitebubble.png");
            Assets.bubble2 = ModAPI.LoadSprite("sprites/lightstonegraybubble.png");
            Assets.bubble3 = ModAPI.LoadSprite("sprites/lightbluebubble.png");
            Assets.bubble4 = ModAPI.LoadSprite("sprites/pastelbluebubble.png");
            Assets.subMine = ModAPI.LoadSprite("sprites/subspacetripmine.png");
            Assets.HyperShot = ModAPI.LoadSprite("sprites/hypershot.png");
            Assets.blackholeCircle = ModAPI.LoadSprite("sprites/blackholecircle.png");
            Assets.scatterBlast = ModAPI.LoadSprite("sprites/scatterprojectile.png");
            Assets.rm_Mine = ModAPI.LoadSprite("sprites/rm_mine.png");
            Assets.guitarNote = ModAPI.LoadSprite("sprites/musicnote1.png");
            Assets.mineNoise = ModAPI.LoadSound("sfx/rm_blink.mp3");
            Assets.remoteNoise = ModAPI.LoadSound("sfx/rm_placebomb.mp3");
            Assets.projHit = ModAPI.LoadSound("sfx/projectilehit.mp3");
            Assets.rocketFly = ModAPI.LoadSound("sfx/rocketwhoosh.mp3");
            Assets.HyperlaserHit = ModAPI.LoadSound("sfx/hyperfade.mp3");
            Assets.JBTaserSound = ModAPI.LoadSound("sfx/jailbreaktaser.mp3");

            Assets.SubspaceExplosion = ModAPI.LoadSound("sfx/explosionsubspace.mp3");
            Assets.RemoteExplosion = ModAPI.LoadSound("sfx/explosionremote.mp3");
            Assets.R80Explosion = ModAPI.LoadSound("sfx/explosionr80.mp3");
            Assets.Explosion = ModAPI.LoadSound("sfx/explosion.mp3");


            Assets.zColor = new Vector3(75f, 200f, 125f); //lets me easily change the rotten color for all entities
            #endregion

            #region entities
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Noob" + ModTag,
                DescriptionOverride = "A new player, and someone who killed you.",
                CategoryOverride = ModAPI.FindCategory("Entities"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/noob.png"),
                NameToOrderByOverride = order2,
                AfterSpawn = (Instance) =>
                {
                    //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("textures/noob.png");
                    var flesh = ModAPI.LoadTexture("texture/flesh.png");
                    var bone = ModAPI.LoadTexture("textures/skeleton.png");


                    var firstSpawn = false;
                    //get person
                    var person = Instance.GetComponent<PersonBehaviour>();


                    if (!Instance.GetComponent<HasBeenSpawned>())
                    {
                        Instance.AddComponent<HasBeenSpawned>();
                        Instance.AddComponent<MultiAvatar>();
                        firstSpawn = true;
                    }



                    var rHuman = Instance.GetComponent<MultiAvatar>();
                    rHuman.skins = new Texture2D[]
                    {
                        ModAPI.LoadTexture("textures/noob.png"), ModAPI.LoadTexture("textures/noob2.png")
                    };

                    if (firstSpawn)
                    {
                        rHuman.SelectedSkin = UnityEngine.Random.Range(0, rHuman.skins.Length);
                        //ModAPI.Notify(rHuman.SelectedSkin);

                    }


                    person.SetBodyTextures(skin, flesh, bone);
                    //person.SetBruiseColor(86, 62, 130);
                    //person.SetSecondBruiseColor(154, 0, 7);
                    //person.SetThirdBruiseColor(207, 206, 120);
                    person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
                    //person.SetBloodColour(108, 0, 4);
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Guest" + ModTag,
                DescriptionOverride = "Use the chat menu to talk to it.",
                CategoryOverride = ModAPI.FindCategory("Entities"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/guest.png"),
                NameToOrderByOverride = order2,
                AfterSpawn = (Instance) =>
                {
                    //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("textures/guestclassic.png");
                    var flesh = ModAPI.LoadTexture("texture/flesh.png");
                    var bone = ModAPI.LoadTexture("textures/skeleton.png");

                    var hat = new CreateHat(Instance.transform.Find("Head"), ModAPI.LoadSprite("textures/pinktastichair.png"), new Vector3(0, 0, 0), Quaternion.Euler(0, 0, 0));

                    var firstSpawn = false;
                    //get person
                    var person = Instance.GetComponent<PersonBehaviour>();

                    if (!Instance.GetComponent<HasBeenSpawned>())
                    {
                        Instance.AddComponent<HasBeenSpawned>();
                        Instance.AddComponent<MultiAvatar>();
                        firstSpawn = true;
                    }



                    var rHuman = Instance.GetComponent<MultiAvatar>();
                    rHuman.skins = new Texture2D[]
                    {
                        ModAPI.LoadTexture("textures/guestclassic.png"), ModAPI.LoadTexture("textures/guestclassic.png"), ModAPI.LoadTexture("textures/guestmodern.png"), ModAPI.LoadTexture("textures/guestmodern.png"), ModAPI.LoadTexture("textures/guestmodern.png")
                    };

                    if (firstSpawn)
                    {
                        rHuman.SelectedSkin = UnityEngine.Random.Range(0, rHuman.skins.Length);
                        //ModAPI.Notify(rHuman.SelectedSkin);

                    }

                    rHuman.flesh = flesh;
                    rHuman.bone = bone;
                    rHuman.accesories = new GameObject[] { hat.hatObject };
                    rHuman.hats = new Sprite[] { ModAPI.LoadSprite("textures/pinktastichair.png"),
                                                ModAPI.LoadSprite("textures/classiccap.png"),
                                                ModAPI.LoadSprite("textures/lavenderupdo.png"),
                                                ModAPI.LoadSprite("textures/truebluehair.png"),
                                                ModAPI.LoadSprite("textures/baseballcap.png") };

                    person.SetBodyTextures(skin, flesh, bone);
                    //person.SetBruiseColor(86, 62, 130);
                    //person.SetSecondBruiseColor(154, 0, 7);
                    //person.SetThirdBruiseColor(207, 206, 120);
                    person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
                    //person.SetBloodColour(108, 0, 4);
                }
            });
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Bacon Hair" + ModTag,
    DescriptionOverride = "the first reason adopt me is still popular",
    CategoryOverride = ModAPI.FindCategory("Entities"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/baconhair.png"),
    NameToOrderByOverride = order2,
    AfterSpawn = (Instance) =>
    {
                    //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("textures/baconhair.png");
        var flesh = ModAPI.LoadTexture("texture/flesh.png");
        var bone = ModAPI.LoadTexture("textures/skeleton.png");

        var hat = new CreateHat(Instance.transform.Find("Head"), ModAPI.LoadSprite("textures/palhair.png"), new Vector3(0, 0, 0), Quaternion.Euler(0, 0, 0));
                    //get person
                    var person = Instance.GetComponent<PersonBehaviour>();

        if (!Instance.GetComponent<HasBeenSpawned>())
        {
            Instance.AddComponent<HasBeenSpawned>();
            Instance.transform.Find("Body").Find("MiddleBody").localScale *= new Vector2(.9f, 1f);
            Instance.transform.Find("Body").Find("LowerBody").localScale *= new Vector2(.9f, 1f);
        }

        person.SetBodyTextures(skin, flesh, bone);
                    //person.SetBruiseColor(86, 62, 130);
                    //person.SetSecondBruiseColor(154, 0, 7);
                    //person.SetThirdBruiseColor(207, 206, 120);
                    person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
                    //person.SetBloodColour(108, 0, 4);
                }
});
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Human"),
NameOverride = "Acorn Hair" + ModTag,
DescriptionOverride = "the second reason adopt me is still popular",
CategoryOverride = ModAPI.FindCategory("Entities"),
ThumbnailOverride = ModAPI.LoadSprite("thumbnails/acornhair.png"),
NameToOrderByOverride = order2,
AfterSpawn = (Instance) =>
{
                    //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("textures/acornhair.png");
var flesh = ModAPI.LoadTexture("texture/flesh.png");
var bone = ModAPI.LoadTexture("textures/skeleton.png");

var hat = new CreateHat(Instance.transform.Find("Head"), ModAPI.LoadSprite("textures/chestnutbun.png"), new Vector3(0, 0, 0), Quaternion.Euler(0, 0, 0));
                    //get person
                    var person = Instance.GetComponent<PersonBehaviour>();

if (!Instance.GetComponent<HasBeenSpawned>())
{
Instance.AddComponent<HasBeenSpawned>();
Instance.transform.Find("Body").localScale *= new Vector2(.8f, 1f);
}

person.SetBodyTextures(skin, flesh, bone);
                    //person.SetBruiseColor(86, 62, 130);
                    //person.SetSecondBruiseColor(154, 0, 7);
                    //person.SetThirdBruiseColor(207, 206, 120);
                    person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
                    //person.SetBloodColour(108, 0, 4);
                }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Builderman" + ModTag,
    DescriptionOverride = "The president of Robloxia.",
    CategoryOverride = ModAPI.FindCategory("Entities"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/builderman.png"),
    NameToOrderByOverride = order2,
    AfterSpawn = (Instance) =>
    {
                    //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("textures/buildermanmodern.png");
        var flesh = ModAPI.LoadTexture("texture/flesh.png");
        var bone = ModAPI.LoadTexture("textures/skeleton.png");

        var hat = new CreateHat(Instance.transform.Find("Head"), ModAPI.LoadSprite("textures/tbchat.png"), new Vector3(0, 0, 0), Quaternion.Euler(0, 0, 0));

        var firstSpawn = false;
                    //get person
                    var person = Instance.GetComponent<PersonBehaviour>();

        if (!Instance.GetComponent<HasBeenSpawned>())
        {
            Instance.AddComponent<HasBeenSpawned>();
            Instance.AddComponent<MultiAvatar>();
            firstSpawn = true;
        }



        var rHuman = Instance.GetComponent<MultiAvatar>();
        rHuman.skins = new Texture2D[]
        {
                        ModAPI.LoadTexture("textures/buildermanmodern.png"), ModAPI.LoadTexture("textures/buildermanclassic.png")
        };

        if (firstSpawn)
        {
            rHuman.SelectedSkin = UnityEngine.Random.Range(0, rHuman.skins.Length);
                        //ModAPI.Notify(rHuman.SelectedSkin);

                    }

        rHuman.flesh = flesh;
        rHuman.bone = bone;
        rHuman.accesories = new GameObject[] { hat.hatObject };
        rHuman.hats = new Sprite[] { ModAPI.LoadSprite("textures/tbchat.png"),
                                                ModAPI.LoadSprite("textures/bchat.png") };

        person.SetBodyTextures(skin, flesh, bone);
                    //person.SetBruiseColor(86, 62, 130);
                    //person.SetSecondBruiseColor(154, 0, 7);
                    //person.SetThirdBruiseColor(207, 206, 120);
                    person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
                    //person.SetBloodColour(108, 0, 4);
                }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Shedletsky" + ModTag,
    DescriptionOverride = "Remember that time he totally owned you in SFOTH?",
    CategoryOverride = ModAPI.FindCategory("Entities"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/shedletsky.png"),
    NameToOrderByOverride = order2,
    AfterSpawn = (Instance) =>
    {
                    //load textures for each layer (see Human textures folder in this repository)
                    var skin = ModAPI.LoadTexture("textures/shedletsky.png");
        var flesh = ModAPI.LoadTexture("texture/flesh.png");
        var bone = ModAPI.LoadTexture("textures/skeleton.png");

        var hat = new CreateHat(Instance.transform.Find("Head"), ModAPI.LoadSprite("textures/telamonhair.png"), new Vector3(0, 0, 0), Quaternion.Euler(0, 0, 0));
                    //get person
                    var person = Instance.GetComponent<PersonBehaviour>();

        person.SetBodyTextures(skin, flesh, bone);
                    //person.SetBruiseColor(86, 62, 130);
                    //person.SetSecondBruiseColor(154, 0, 7);
                    //person.SetThirdBruiseColor(207, 206, 120);
                    person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
                    //person.SetBloodColour(108, 0, 4);
                }
});
            //ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Human"),
            //    NameOverride = "Pizza Boy" + ModTag,
            //    DescriptionOverride = "The best pal that brings you pizza. Unless you’re allergic to pizza- then he's the worst pal. [Work at a Pizza Place]",
            //    CategoryOverride = ModAPI.FindCategory("Entities"),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/shedletsky.png"),
            //    NameToOrderByOverride = order2,
            //    AfterSpawn = (Instance) =>
            //    {
            //        //load textures for each layer (see Human textures folder in this repository)
            //        var skin = ModAPI.LoadTexture("textures/pizzaboy.png");
            //        var flesh = ModAPI.LoadTexture("texture/flesh.png");
            //        var bone = ModAPI.LoadTexture("textures/skeleton.png");

            //        var hat = new CreateHat(Instance.transform.Find("Head"), ModAPI.LoadSprite("textures/redrobloxvisor.png"), new Vector3(0, 0, 0), Quaternion.Euler(0, 0, 0));
            //        //get person
            //        var person = Instance.GetComponent<PersonBehaviour>();

            //        person.SetBodyTextures(skin, flesh, bone);
            //        //person.SetBruiseColor(86, 62, 130);
            //        //person.SetSecondBruiseColor(154, 0, 7);
            //        //person.SetThirdBruiseColor(207, 206, 120);
            //        person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
            //        //person.SetBloodColour(108, 0, 4);
            //    }
            //});
            //            ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Human"),
            //    NameOverride = "Copy and Paste" + ModTag, //i feel like this names more accurate
            //    DescriptionOverride = "A relatively weak, toxic creature. It often smells of sweat and travels in packs.",
            //    CategoryOverride = ModAPI.FindCategory("Entities"),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/guest.png"),
            //    NameToOrderByOverride = order2,
            //    AfterSpawn = (Instance) =>
            //    {
            //        //load textures for each layer (see Human textures folder in this repository)
            //        var skin = ModAPI.LoadTexture("textures/slender1.png");
            //        var flesh = ModAPI.LoadTexture("texture/flesh.png");
            //        var bone = ModAPI.LoadTexture("textures/skeleton.png");

            //        var hat = new CreateHat(Instance.transform.Find("Head"), ModAPI.LoadSprite("textures/slenderhair1.png"), new Vector3(0, 0, 0), Quaternion.Euler(0, 0, 0));

            //        var firstSpawn = false;
            //        //get person
            //        var person = Instance.GetComponent<PersonBehaviour>();

            //        if (!Instance.GetComponent<HasBeenSpawned>())
            //        {
            //            Instance.AddComponent<HasBeenSpawned>();
            //            Instance.AddComponent<MultiAvatar>();
            //            firstSpawn = true;
            //        }
                    


            //        var rHuman = Instance.GetComponent<MultiAvatar>();
            //        rHuman.skins = new Texture2D[]
            //        {
            //            ModAPI.LoadTexture("textures/slender1.png"), ModAPI.LoadTexture("textures/slender2.png")//, ModAPI.LoadTexture("textures/guestmodern.png"), ModAPI.LoadTexture("textures/guestmodern.png"), ModAPI.LoadTexture("textures/guestmodern.png")
            //        };

            //        if (firstSpawn)
            //        {
            //            rHuman.SelectedSkin = UnityEngine.Random.Range(0, rHuman.skins.Length);
            //            //ModAPI.Notify(rHuman.SelectedSkin);
            //            foreach (LimbBehaviour limb in person.Limbs)
            //            {
            //                limb.BreakingThreshold *= .75f;
            //                if (limb.RoughClassification != LimbBehaviour.BodyPart.Head)
            //                {
            //                    limb.gameObject.transform.localScale *= new Vector2(.85f, 1f);
            //                }
            //            }

            //        }

            //        rHuman.flesh = flesh;
            //        rHuman.bone = bone;
            //        rHuman.accesories = new GameObject[] { hat.hatObject };
            //        rHuman.hats = new Sprite[] { ModAPI.LoadSprite("textures/slenderhair1.png"),
            //                                    ModAPI.LoadSprite("textures/slenderhair2.png") };

            //        person.SetBodyTextures(skin, flesh, bone);
            //        //person.SetBruiseColor(86, 62, 130);
            //        //person.SetSecondBruiseColor(154, 0, 7);
            //        //person.SetThirdBruiseColor(207, 206, 120);
            //        person.SetRottenColour((byte)Assets.zColor.x, (byte)Assets.zColor.y, (byte)Assets.zColor.z);
            //        //person.SetBloodColour(108, 0, 4);
            //    }
            //});
            #endregion
            #region items
            #region food
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Bloxy Cola" + ModTag,
                DescriptionOverride = "Warning: May be habit forming.",
                CategoryOverride = ModAPI.FindCategory("Misc."),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/bloxycola.png"),
                NameToOrderByOverride = order,
                AfterSpawn = (Instance) =>
                {
                    var sprite = Instance.GetComponent<SpriteRenderer>();
                    sprite.sprite = ModAPI.LoadSprite("sprites/bloxycola.png");
                    Instance.FixColliders();

                    var equipsound = ModAPI.LoadSound("sfx/sodaopening.mp3");

                    

                    var edible = Instance.GetOrAddComponent<SimpleEdibleBehaviour>();
                    edible.useSound = ModAPI.LoadSound("sfx/sodaslurp.mp3");
                    edible.isFood = false;
                    //edible.AudioPlayer = audioplay;
                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(0f, 0f) * ModAPI.PixelSize };

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Turkey Leg" + ModTag,
                DescriptionOverride = "Forks are lame...",
                CategoryOverride = ModAPI.FindCategory("Misc."),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/turkeyleg.png"),
                NameToOrderByOverride = order,
                AfterSpawn = (Instance) =>
                {
                    var sprite = Instance.GetComponent<SpriteRenderer>();
                    sprite.sprite = ModAPI.LoadSprite("sprites/turkeyleg.png");
                    Destroy(Instance.GetComponent<BoxCollider2D>());
                    var collider = Instance.AddComponent<PolygonCollider2D>();
                    collider.points = new Vector2[]
                        {
                        (new Vector2(0f,6f) * ModAPI.PixelSize),
                        (new Vector2(-2.5f,5f) * ModAPI.PixelSize),
                        (new Vector2(-1.5f,-1f) * ModAPI.PixelSize),
                        (new Vector2(-0.5f,-3f) * ModAPI.PixelSize),
                        (new Vector2(-1.5f,-6f) * ModAPI.PixelSize),
                        (new Vector2(1.5f,-6f) * ModAPI.PixelSize),
                        (new Vector2(.5f,-3f) * ModAPI.PixelSize),
                        (new Vector2(1.5f,-1f) * ModAPI.PixelSize),
                        (new Vector2(2.5f,5f) * ModAPI.PixelSize)
                        };
                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(0f, -3.5f) * ModAPI.PixelSize };

                    phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                    var equipsound = ModAPI.LoadSound("sfx/gobble.mp3");

                    var edible = Instance.GetOrAddComponent<SimpleEdibleBehaviour>();
                    edible.useSound = ModAPI.LoadSound("sfx/yum.mp3");
                    edible.isFood = true;
                    //edible.AudioPlayer = audioplay;
                    edible.healamount = 1.6f;
                    edible.delay = .8f;

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);

                }
            });
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Rod"),
    NameOverride = "Chezburger" + ModTag,
    DescriptionOverride = "U can has cheezburger!",
    CategoryOverride = ModAPI.FindCategory("Misc."),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/chezburger.png"),
    NameToOrderByOverride = order,
    AfterSpawn = (Instance) =>
    {
        var sprite = Instance.GetComponent<SpriteRenderer>();
        sprite.sprite = ModAPI.LoadSprite("sprites/chezburger.png");
        var box = Instance.GetComponent<BoxCollider2D>();
        box.size = new Vector2(7f, 6f) * ModAPI.PixelSize;

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        phys.HoldingPositions = new Vector3[] { new Vector3(0f, -1f) * ModAPI.PixelSize };

        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

        var equipsound = ModAPI.LoadSound("sfx/chezburgerplz.mp3");

        var edible = Instance.GetOrAddComponent<SimpleEdibleBehaviour>();
        edible.useSound = ModAPI.LoadSound("sfx/mmmchezburger.mp3");
        edible.isFood = true;
        //edible.AudioPlayer = audioplay;
        edible.healamount = 1.6f;
        edible.delay = .8f;

        var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
        tempSource.PlayOneShot(equipsound);
        Destroy(tempSource, equipsound.length);

    }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Rod"),
    NameOverride = "Witches Brew" + ModTag,
    DescriptionOverride = "Do the Brew! Warning: may cause freakish deformities.",
    CategoryOverride = ModAPI.FindCategory("Misc."),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/witchesbrew.png"),
    NameToOrderByOverride = order,
    AfterSpawn = (Instance) =>
    {
        var sprite = Instance.GetComponent<SpriteRenderer>();
        sprite.sprite = ModAPI.LoadSprite("sprites/witchesbrew.png");
        Instance.FixColliders();

        var equipsound = ModAPI.LoadSound("sfx/sodaopening.mp3");

        var edible = Instance.GetOrAddComponent<WitchesBrew>();
        edible.useSound = ModAPI.LoadSound("sfx/sodaslurp.mp3");
        edible.isFood = false;
        //edible.AudioPlayer = audioplay;

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        phys.HoldingPositions = new Vector3[] { new Vector3(0f, 0f) * ModAPI.PixelSize };

        var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
        tempSource.PlayOneShot(equipsound);
        Destroy(tempSource,equipsound.length);

    }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Rod"),
    NameOverride = "Cake" + ModTag,
    DescriptionOverride = "The cake is the truth.",
    CategoryOverride = ModAPI.FindCategory("Misc."),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/cake.png"),
    NameToOrderByOverride = order,
    AfterSpawn = (Instance) =>
    {
        var sprite = Instance.GetComponent<SpriteRenderer>();
        sprite.sprite = ModAPI.LoadSprite("sprites/cake.png");
        var box = Instance.GetComponent<BoxCollider2D>();
        box.size = new Vector2(7f, 8f) * ModAPI.PixelSize;
        box.offset = new Vector2(1f, -1f) * ModAPI.PixelSize;

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        phys.HoldingPositions = new Vector3[] { new Vector3(-3f, 0f) * ModAPI.PixelSize };

        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

        var equipsound = ModAPI.LoadSound("sfx/yummy.mp3");

        var edible = Instance.GetOrAddComponent<SimpleEdibleBehaviour>();
        edible.useSound = ModAPI.LoadSound("sfx/yummy.mp3");
        edible.isFood = true;
        //edible.AudioPlayer = audioplay;
        edible.healamount = 1.6f;
        edible.delay = .8f;

        var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
        tempSource.PlayOneShot(equipsound);
        Destroy(tempSource, equipsound.length);

    }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Rod"),
    NameOverride = "ROBLOX Birthday Cake 2010" + ModTag,
    DescriptionOverride = "Celebrate our birthday with this delicious birthday cake gear!",
    CategoryOverride = ModAPI.FindCategory("Misc."),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/2010cake.png"),
    NameToOrderByOverride = order,
    AfterSpawn = (Instance) =>
    {
        var sprite = Instance.GetComponent<SpriteRenderer>();
        sprite.sprite = ModAPI.LoadSprite("sprites/2010cake.png");
        var box = Instance.GetComponent<BoxCollider2D>();
        box.size = new Vector2(7f, 8f) * ModAPI.PixelSize;
        box.offset = new Vector2(1f, -1f) * ModAPI.PixelSize;

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        phys.HoldingPositions = new Vector3[] { new Vector3(-3f, 0f) * ModAPI.PixelSize };

        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

        var equipsound = ModAPI.LoadSound("sfx/cakemmm.mp3");

        var edible = Instance.GetOrAddComponent<SimpleEdibleBehaviour>();
        edible.useSound = ModAPI.LoadSound("sfx/happybirthday.mp3");
        edible.isFood = true;
        //edible.AudioPlayer = audioplay;
        edible.healamount = 1.6f;
        edible.delay = .8f;

        var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
        tempSource.PlayOneShot(equipsound);
        Destroy(tempSource, equipsound.length);

    }
});
            //                        ModAPI.Register(
            //new Modification() 
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Rod"),
            //    NameOverride = "Monster Mash Dance Potion" + ModTag, //maybe one day
            //    DescriptionOverride = "They'll be a graveyard smash with this thrilling dance potion.",
            //    CategoryOverride = ModAPI.FindCategory("Misc."),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/monstermash.png"),
            //    NameToOrderByOverride = order,
            //    AfterSpawn = (Instance) =>
            //    {
            //        var sprite = Instance.GetComponent<SpriteRenderer>();
            //        sprite.sprite = ModAPI.LoadSprite("sprites/monstermash.png");
            //        Instance.FixColliders();

            //        var audioplay = Instance.AddComponent<AudioSource>();

            //        var edible = Instance.GetOrAddComponent<DancePotion>();
            //        edible.useSound = ModAPI.LoadSound("sfx/sodaslurp.mp3");
            //        edible.Dance = "Monster Mash";
            //        edible.AudioPlayer = audioplay;

            //        var phys = Instance.GetComponent<PhysicalBehaviour>();
            //        phys.HoldingPositions = new Vector3[] { new Vector3(0f, 0f) * ModAPI.PixelSize };

            //    }
            //});
            #endregion
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "LinkedSword" + ModTag,
                DescriptionOverride = "With blood and iron.",
                CategoryOverride = ModAPI.FindCategory("Melee"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/linkedsword.png"),
                NameToOrderByOverride = order,
                AfterSpawn = (Instance) =>
                {
                    var sprite = Instance.GetComponent<SpriteRenderer>();
                    sprite.sprite = ModAPI.LoadSprite("sprites/linkedsword.png");

                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(0f, -18.5f) * ModAPI.PixelSize };

                    phys.Properties = Instantiate(phys.Properties);
                    phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
                    phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


                    var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);

                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "Darkheart" + ModTag,
                DescriptionOverride = "It's darker than RGB(0,0,0).",
                CategoryOverride = ModAPI.FindCategory("Melee"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/darkheart.png"),
                NameToOrderByOverride = order,
                AfterSpawn = (Instance) =>
                {
                    var sprite = Instance.GetComponent<SpriteRenderer>();
                    sprite.sprite = ModAPI.LoadSprite("sprites/darkheart.png");

                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(0f, -18.5f) * ModAPI.PixelSize };

                    phys.Properties = Instantiate(phys.Properties);
                    phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
                    phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


                    var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

                    Instance.GetOrAddComponent<Darkheart>();

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);

                }
            });
            ModAPI.Register(
 new Modification()
 {
     OriginalItem = ModAPI.FindSpawnable("Sword"),
     NameOverride = "Illumina" + ModTag,
     DescriptionOverride = "Telamon's favorite weapon from Sword Fight on the Heights. It is light, agile, and deadly.",
     CategoryOverride = ModAPI.FindCategory("Melee"),
     ThumbnailOverride = ModAPI.LoadSprite("thumbnails/illumina.png"),
     NameToOrderByOverride = order,
     AfterSpawn = (Instance) =>
     {
         var sprite = Instance.GetComponent<SpriteRenderer>();
         sprite.sprite = ModAPI.LoadSprite("sprites/illumina.png");
         var glow = ModAPI.CreateLight(Instance.transform, Color.magenta, 5, 1);
         var phys = Instance.GetComponent<PhysicalBehaviour>();
         phys.HoldingPositions = new Vector3[] { new Vector3(0f, -18.5f) * ModAPI.PixelSize };

         phys.Properties = Instantiate(phys.Properties);
         phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
         phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };
         phys.StabReleaseSpeedModifier = 10f;

         var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

         Instance.GetOrAddComponent<Illumina>();

         var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
         tempSource.PlayOneShot(equipsound);
         Destroy(tempSource, equipsound.length);

     }
 });
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Sword"),
    NameOverride = "Windforce" + ModTag,
    DescriptionOverride = "She's like the wind.",
    CategoryOverride = ModAPI.FindCategory("Melee"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/windforce.png"),
    NameToOrderByOverride = order,
    AfterSpawn = (Instance) =>
{
    var sprite = Instance.GetComponent<SpriteRenderer>();
    sprite.sprite = ModAPI.LoadSprite("sprites/windforce.png");

    var phys = Instance.GetComponent<PhysicalBehaviour>();
    phys.HoldingPositions = new Vector3[] { new Vector3(0f, -18.5f) * ModAPI.PixelSize };

    phys.Properties = Instantiate(phys.Properties);
    phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
    phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };
    phys.StabReleaseSpeedModifier = 10f;
    //phys.Properties.SharpAxes = new SharpAxis[] { new SharpAxis(Vector2.up, 26f * ModAPI.PixelSize, 0f, true, false) };

    var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
    tempSource.PlayOneShot(equipsound);
    Destroy(tempSource, equipsound.length);

    Instance.GetOrAddComponent<Windforce>();

}
});
            //ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Sword"),
            //    NameOverride = "Ghostwalker" + ModTag,
            //    DescriptionOverride = "The boast of heraldry, the pomp of power,\n And all that beauty, all that wealth e'er gave, \n Awaits alike th' inevitable hour: \n The paths of glory lead but to the grave.",
            //    CategoryOverride = ModAPI.FindCategory("Melee"),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/ghostwalker.png"),
            //    NameToOrderByOverride = order,
            //    AfterSpawn = (Instance) =>
            //    {
            //        var sprite = Instance.GetComponent<SpriteRenderer>();
            //        sprite.sprite = ModAPI.LoadSprite("sprites/ghostwalker.png");

            //        var phys = Instance.GetComponent<PhysicalBehaviour>();
            //        phys.HoldingPositions = new Vector3[] { new Vector3(0f, -18.5f) * ModAPI.PixelSize };

            //        phys.Properties = Instantiate(phys.Properties);
            //        phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
            //        phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


            //        var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

            //        var audioplay = Instance.AddComponent<AudioSource>();
            //        audioplay.PlayOneShot(equipsound);

            //        Instance.AddComponent<Ghostwalker>();

            //    }
            //});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Sword"),
    NameOverride = "Firebrand" + ModTag,
    DescriptionOverride = "O! for a muse of fire, that would ascend the brightest heaven of invention.",
    CategoryOverride = ModAPI.FindCategory("Melee"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/firebrand.png"),
    NameToOrderByOverride = order,
    AfterSpawn = (Instance) =>
    {
        foreach (var coll in Instance.GetComponents<Collider2D>())
        {
            Destroy(coll);
        }

        var collider = Instance.AddComponent<BoxCollider2D>();
        collider.size = new Vector2(4f, 79f) * ModAPI.PixelSize;
        collider.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
        var collider2 = Instance.AddComponent<BoxCollider2D>();
        collider2.size = new Vector2(18f, 3f) * ModAPI.PixelSize;
        collider2.offset = new Vector2(0f, -18f) * ModAPI.PixelSize;

        var sprite = Instance.GetComponent<SpriteRenderer>();
        sprite.sprite = ModAPI.LoadSprite("sprites/firebrand.png");

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        phys.HoldingPositions = new Vector3[] { new Vector3(0f, -28.5f) * ModAPI.PixelSize };

        phys.Properties = Instantiate(phys.Properties);
        phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
        phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


        var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

        var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
        tempSource.PlayOneShot(equipsound);
        Destroy(tempSource, equipsound.length);

        Instance.GetOrAddComponent<Firebrand>();

    }
});
            //ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Sword"),
            //    NameOverride = "Icedagger" + ModTag,
            //    DescriptionOverride = "Is this a dagger which I see before me, The handle toward my hand? Come, let me clutch thee. \n I have thee not, and yet I see thee still. \n Art thou not, fatal vision, sensible \n To feeling as to sight? or art thou but \n A dagger of the mind, a false creation, \n Proceeding from the heat-oppressed brain?",
            //    CategoryOverride = ModAPI.FindCategory("Melee"),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/icedagger.png"),
            //    NameToOrderByOverride = order,
            //    AfterSpawn = (Instance) =>
            //    {

            //        foreach (var coll in Instance.GetComponents<Collider2D>())
            //        {
            //            Destroy(coll);
            //        }


            //        var collider = Instance.AddComponent<BoxCollider2D>();
            //        collider.size = new Vector2(2f, 30f) * ModAPI.PixelSize;
            //        collider.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;

            //        var sprite = Instance.GetComponent<SpriteRenderer>();
            //        sprite.sprite = ModAPI.LoadSprite("sprites/icedagger.png");

            //        var phys = Instance.GetComponent<PhysicalBehaviour>();
            //        phys.HoldingPositions = new Vector3[] { new Vector3(0f, -11f) * ModAPI.PixelSize };

            //        phys.Properties = Instantiate(ModAPI.FindPhysicalProperties("Ice"));
            //        phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
            //        phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


            //        var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

            //        phys.PlayClipOnce(equipsound);

            //        Instance.AddComponent<IceDagger>();

            //    }
            //});
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "Brigand's Sword" + ModTag,
                DescriptionOverride = "Stand and deliver!",
                CategoryOverride = ModAPI.FindCategory("Melee"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/brigandssword.png"),
                NameToOrderByOverride = order,
                AfterSpawn = (Instance) =>
                {
                    var sprite = Instance.GetComponent<SpriteRenderer>();
                    sprite.sprite = ModAPI.LoadSprite("sprites/brigandssword.png");

                    var collider = Instance.GetComponent<BoxCollider2D>();
                    collider.size = new Vector2(3f, 57f) * ModAPI.PixelSize;
                    collider.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                    var collider2 = Instance.AddComponent<BoxCollider2D>();
                    collider2.size = new Vector2(13f, 2f) * ModAPI.PixelSize;
                    collider2.offset = new Vector2(0f, -11f) * ModAPI.PixelSize;

                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(0f, -18.5f) * ModAPI.PixelSize };

                    phys.Properties = Instantiate(phys.Properties);
                    phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
                    phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


                    var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);

                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Ban Hammer" + ModTag,
                DescriptionOverride = "For those favored by Telamon. Perfect for when you just have to drop the hammer on someone.",
                CategoryOverride = ModAPI.FindCategory("Melee"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/banhammer.png"),
                NameToOrderByOverride = order,
                AfterSpawn = (Instance) =>
                {
                    var sprite = Instance.GetComponent<SpriteRenderer>();
                    sprite.sprite = ModAPI.LoadSprite("sprites/banhammer.png");

                    var collider = Instance.GetComponent<BoxCollider2D>();
                    collider.size = new Vector2(5f, 58f) * ModAPI.PixelSize;
                    collider.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                    var collider2 = Instance.AddComponent<BoxCollider2D>();
                    collider2.size = new Vector2(33f, 19f) * ModAPI.PixelSize;
                    collider2.offset = new Vector2(0f, 17.5f) * ModAPI.PixelSize;

                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(0f, -16f) * ModAPI.PixelSize };

                    phys.Properties = Instantiate(phys.Properties);
                    phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/whack.mp3") };
                    phys.TrueInitialMass = 2.1f;
                    //phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/whack.mp3") };


                    var equipsound = ModAPI.LoadSound("sfx/cheer.mp3");

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);

                }
            });
            //ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Rod"),
            //    NameOverride = "Azure Periastron Alpha" + ModTag,
            //    DescriptionOverride = "Only when two stars are at their closest point, can the material for this sword be collected.",
            //    CategoryOverride = ModAPI.FindCategory("Melee"),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/azureperiastron.png"),
            //    NameToOrderByOverride = order,
            //    AfterSpawn = (Instance) =>
            //    {
            //        var sprite = Instance.GetComponent<SpriteRenderer>();
            //        sprite.sprite = ModAPI.LoadSprite("sprites/azureperiastronbase.png");

            //        var collider = Instance.GetComponent<BoxCollider2D>();
            //        collider.size = new Vector2(3f, 24f) * ModAPI.PixelSize;
            //        collider.offset = new Vector2(0f, -1f) * ModAPI.PixelSize;
            //        var collider2 = Instance.AddComponent<BoxCollider2D>();
            //        collider2.size = new Vector2(15f, 8f) * ModAPI.PixelSize;
            //        collider2.offset = new Vector2(0f, 4.5f) * ModAPI.PixelSize;

            //        var phys = Instance.GetComponent<PhysicalBehaviour>();
            //        phys.HoldingPositions = new Vector3[] { new Vector3(0f, -5f) * ModAPI.PixelSize };

            //        phys.Properties = Instantiate(phys.Properties);
            //        phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/perialunge.mp3") };
            //        phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


            //        var equipsound = ModAPI.LoadSound("sfx/azurecounter.mp3");

            //        var audioplay = Instance.AddComponent<AudioSource>();
            //        audioplay.PlayOneShot(equipsound);




            //        var blade = ModAPI.CreatePhysicalObject("Periastron", ModAPI.LoadSprite("sprites/azureperiastron.png"));
            //        blade.transform.SetParent(Instance.transform);
            //        blade.transform.localPosition = new Vector2(0f, 24.5f) * ModAPI.PixelSize;
            //        //blade.layer = 17;

            //        var Joint = Instance.AddComponent<HingeJoint2D>();
            //        Joint.useLimits = true;
            //        var limrit = Joint.GetComponent<JointAngleLimits2D>();
            //        limrit.max = 0;
            //        limrit.min = 0;
            //        Joint.limits = limrit;
            //        Joint.anchor = new Vector3(0f, 12.5f) * ModAPI.PixelSize;
            //        Joint.connectedBody = blade.GetComponent<Rigidbody2D>();
            //        Joint.connectedAnchor = new Vector3(0f, -12.5f * ModAPI.PixelSize);
            //        Joint.enableCollision = false;
            //        Joint.breakForce = 99999999999999;

            //    }
            //});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"),
    NameOverride = "Superball" + ModTag,
    DescriptionOverride = "BoingboboboBoing",
    CategoryOverride = ModAPI.FindCategory("Misc."),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/superball.png"),
    NameToOrderByOverride = order,
    AfterSpawn = (Instance) =>
    {
        Destroy(Instance.GetComponent<RandomSpriteBehaviour>());
        var sprite = Instance.GetComponent<SpriteRenderer>();
        sprite.sprite = ModAPI.LoadSprite("sprites/superball.png");

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        //phys.HoldingPositions = new Vector3[] { new Vector3(0f, 0f) * ModAPI.PixelSize };


        phys.Properties = Instantiate(ModAPI.FindPhysicalProperties("Rubber"));

        var Mat = new PhysicsMaterial2D()
        {
            friction = ModAPI.FindPhysicalProperties("Bowling Ball").PhysicMaterial.friction,
            bounciness = .5f
        };


        phys.Properties.ImpactIntensityMutliplier = 3f;
        phys.Properties.PhysicMaterial = Mat;
        phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/boing.mp3") };
        phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/boing.mp3") };
        phys.Properties.SlidingLoop = ModAPI.FindPhysicalProperties("Bowling Ball").SlidingLoop;

        phys.TrueInitialMass = 0.8f;



        //var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

        
        //audioplay.PlayOneShot(equipsound);


    }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Stick"),
    NameOverride = "Banana Peel" + ModTag,
    DescriptionOverride = "Always slippery in cartoons, but are they ever in real life? I don't know, but they sure are hilarious!",
    CategoryOverride = ModAPI.FindCategory("Misc."),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/bananapeel.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
    NameToOrderByOverride = "Roblox",
    AfterSpawn = (Instance) =>
    {
        var box = Instance.GetComponent<BoxCollider2D>();
        Destroy(box);
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/bananapeel.png");
        var collider = Instance.AddComponent<PolygonCollider2D>();
        collider.CreatePrimitive(3, Vector2.one * 4 * ModAPI.PixelSize, Vector2.zero);
        //collider.size = new Vector2(6, 6);

        //fuse.AS = AS;
        //var AS = Instance.AddComponent<AudioSource>();

        var peel = Instance.GetOrAddComponent<Peel>();
        var equipsound = ModAPI.LoadSound("sfx/placepeel.mp3");
        peel.place = equipsound;
        //peel.AS = AS;
        peel.slip = ModAPI.LoadSound("sfx/slip.mp3");
        //fuse.pram = (uint rayCount, Vector3 pos, float range, float force, bool createFx, bool big, float dismember, int shrapnelCount); Tuple = (2, Random.insideUnitCircle, 12f, 2f, true, false, 100f, 0);


        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Soft"); //why not
        phys.TrueInitialMass = 0.03f;
        phys.Properties = prop;

        var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
        tempSource.PlayOneShot(equipsound);
        Destroy(tempSource, equipsound.length);
    }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Stick"),
    NameOverride = "Bomb" + ModTag,
    DescriptionOverride = "Someone set us up the bomb! Make your time.",
    CategoryOverride = ModAPI.FindCategory("Explosives"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/fusebomb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
    NameToOrderByOverride = "Roblox",
    AfterSpawn = (Instance) =>
            {
                var box = Instance.GetComponent<BoxCollider2D>();
                Destroy(box);
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/fusebomb.png");
                var collider = Instance.AddComponent<CircleCollider2D>();
                collider.radius = 6.5f * ModAPI.PixelSize;

                //var AS = Instance.AddComponent<AudioSource>();
                if (!(Instance.GetComponent<HasBeenSpawned>()))
                {
                    Instance.AddComponent<FuseBomb>();
                    Instance.AddComponent<HasBeenSpawned>();
                }
                var fuse = Instance.GetComponent<FuseBomb>();
                fuse.fuse = ModAPI.LoadSound("sfx/clickfast.mp3");
                //fuse.AS = AS;

                var phys = Instance.GetComponent<PhysicalBehaviour>();
                var prop = ModAPI.FindPhysicalProperties("Bowling Ball");
                phys.TrueInitialMass = .8f;
                phys.Properties = prop;
            }
});
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Stick"),
    NameOverride = "R-80" + ModTag,
    DescriptionOverride = "R-80s are so fun that they're banned in all 50 states. Celebrate the birth of your country by blowing up a small piece of it!",
    CategoryOverride = ModAPI.FindCategory("Explosives"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/r80.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
    NameToOrderByOverride = "Roblox",
    AfterSpawn = (Instance) =>
                {
                    var box = Instance.GetComponent<BoxCollider2D>();
                    Destroy(box);
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/r80.png");
                    var collider = Instance.AddComponent<BoxCollider2D>();
                    collider.size = new Vector3(11f, 20f) * ModAPI.PixelSize;

                    //var AS = Instance.AddComponent<AudioSource>();
                    if (!(Instance.GetComponent<HasBeenSpawned>()))
                    {
                        Instance.AddComponent<R80>();
                        Instance.AddComponent<HasBeenSpawned>();
                    }
                    var fuse = Instance.GetComponent<R80>();
                    //fuse.AS = AS;
                    fuse.fuse = ModAPI.LoadSound("sfx/bombfuse.mp3");
                    //fuse.AS = AS;


                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    var prop = ModAPI.FindPhysicalProperties("Plastic");
                    phys.TrueInitialMass = 0.3f;
                    phys.Properties = prop;
                }
});

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Stick"),
                NameOverride = "XLS Mark II Pulse Laser Pistol" + ModTag,
                DescriptionOverride = "Standard issue in the intergalactic police corps.",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/xlsmark2.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                NameToOrderByOverride = "Roblox",
                AfterSpawn = (Instance) =>
                {
                    var box = Instance.GetComponent<BoxCollider2D>();
                    Destroy(box);
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/xlsmark2.png");
                    var collider = Instance.AddComponent<BoxCollider2D>();
                    collider.size = new Vector3(38f, 2f) * ModAPI.PixelSize;
                    collider.offset = new Vector3(.5f, 2.5f) * ModAPI.PixelSize;
                    var collider1 = Instance.AddComponent<BoxCollider2D>();
                    collider1.size = new Vector3(17f, 5f) * ModAPI.PixelSize;
                    collider1.offset = new Vector3(0f, 2f) * ModAPI.PixelSize;
                    var collider2 = Instance.AddComponent<BoxCollider2D>();
                    collider2.size = new Vector3(17f, 5f) * ModAPI.PixelSize;
                    collider2.offset = new Vector3(0f, 2f) * ModAPI.PixelSize;
                    var collider3 = Instance.AddComponent<CircleCollider2D>();
                    collider3.radius = 2.5f * ModAPI.PixelSize;
                    collider3.offset = new Vector3(-20f, 2f) * ModAPI.PixelSize;
                    var collider4 = Instance.AddComponent<CircleCollider2D>();
                    collider4.radius = 3f * ModAPI.PixelSize;
                    collider4.offset = new Vector3(19.5f, 2.5f) * ModAPI.PixelSize;
                    var collider5 = Instance.AddComponent<BoxCollider2D>();
                    collider5.size = new Vector3(5f, 7f) * ModAPI.PixelSize;
                    collider5.offset = new Vector3(-7f, -5f) * ModAPI.PixelSize;

                    var equipsound = ModAPI.LoadSound("sfx/zap.mp3");

                    

                    var AS = Instance.AddComponent<AudioSource>();
                    if (!(Instance.GetComponent<HasBeenSpawned>()))
                    {
                        Instance.AddComponent<ShooterBehaviour>();
                        Instance.AddComponent<HasBeenSpawned>();
                    }
                    var shooter = Instance.GetComponent<ShooterBehaviour>();
                    //fuse.AS = AS;
                    shooter.Recoil = .5f;
                    shooter.InaccuracyMultiplier = .02f;
                    shooter.Delay = .2f;
                    shooter.particles = new string[] { "" };
                    shooter.ProjectileType = typeof(XLSProjectile);
                    shooter.clips = new AudioClip[] { ModAPI.LoadSound("sfx/pew.mp3") };
                    //shooter.audio = audioplay;
                    shooter.barrelPosition = new Vector2(22.5f, 2.5f) * ModAPI.PixelSize;



                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(-7f, -5f) * ModAPI.PixelSize };
                    var prop = ModAPI.FindPhysicalProperties("Plastic");
                    phys.TrueInitialMass = 0.5f;
                    phys.Properties = prop;

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Hyperlaser Gun" + ModTag,
                DescriptionOverride = "Everyone knows that blue is the fastest color laser beam. That's why it's a one hit KO.",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/hyperlaser.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                NameToOrderByOverride = "Roblox",
                AfterSpawn = (Instance) =>
                {
                    var box = Instance.GetComponent<BoxCollider2D>();
                    Destroy(box);
                    var glow = ModAPI.CreateLight(Instance.transform, Color.cyan, 2, 1);
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/hyperlaser.png");
                    var collider = Instance.AddComponent<BoxCollider2D>();
                    collider.size = new Vector3(10f, 5f) * ModAPI.PixelSize;
                    collider.offset = new Vector3(3f, 1f) * ModAPI.PixelSize;
                    var collider1 = Instance.AddComponent<BoxCollider2D>();
                    collider1.size = new Vector3(7f, 9f) * ModAPI.PixelSize;
                    collider1.offset = new Vector3(-5.5f, 0f) * ModAPI.PixelSize;
                    //var equipsound = ModAPI.LoadSound("sfx/zap.mp3");

                    //var audioplay = Instance.AddComponent<AudioSource>();
                    //audioplay.PlayOneShot(equipsound);

                    var AS = Instance.AddComponent<AudioSource>();
                    if (!(Instance.GetComponent<HasBeenSpawned>()))
                    {
                        Instance.AddComponent<ShooterBehaviour>();
                        Instance.AddComponent<HasBeenSpawned>();
                    }
                    var shooter = Instance.GetComponent<ShooterBehaviour>();
                    //fuse.AS = AS;
                    shooter.Recoil = 0f;
                    shooter.InaccuracyMultiplier = .01f;
                    shooter.Delay = 1.35f;
                    shooter.particles = new string[] { "" };
                    shooter.ProjectileType = typeof(Hyperlaser);
                    shooter.clips = new AudioClip[] { ModAPI.LoadSound("sfx/hyperfire.mp3"), ModAPI.LoadSound("sfx/hyperreload.mp3") };
                    //shooter.audio = audioplay;
                    shooter.barrelPosition = new Vector2(9f, 1.5f) * ModAPI.PixelSize;
                    shooter.reloadTime = .6f;


                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(-7f, -2f) * ModAPI.PixelSize };
                    var prop = ModAPI.FindPhysicalProperties("Plastic");
                    phys.TrueInitialMass = 0.5f;
                    phys.Properties = prop;
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                NameOverride = "Rocket Launcher" + ModTag,
                DescriptionOverride = "ffffffsss boom",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/rocketlauncher.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                NameToOrderByOverride = "Roblox",
                AfterSpawn = (Instance) =>
                {
                    var boxes = Instance.GetComponents<Collider2D>();
                    foreach (Collider2D box in boxes)
                    {
                        Destroy(box);
                    }
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/rocketlauncher.png");
                    var collider = Instance.AddComponent<BoxCollider2D>();
                    collider.size = new Vector3(54f, 5f) * ModAPI.PixelSize;
                    collider.offset = new Vector3(0f, .5f) * ModAPI.PixelSize;
                    var collider1 = Instance.AddComponent<BoxCollider2D>();
                    collider1.size = new Vector3(2f, 10f) * ModAPI.PixelSize;
                    collider1.offset = new Vector3(-15f, 2f) * ModAPI.PixelSize;
                    var collider2 = Instance.AddComponent<BoxCollider2D>();
                    collider2.size = new Vector3(2f, 6f) * ModAPI.PixelSize;
                    collider2.offset = new Vector3(9f, -4f) * ModAPI.PixelSize;
                    var collider5 = Instance.AddComponent<BoxCollider2D>();
                    collider5.size = new Vector3(2f, 4f) * ModAPI.PixelSize;
                    collider5.offset = new Vector3(19f, -3f) * ModAPI.PixelSize;

                    //var equipsound = ModAPI.LoadSound("sfx/zap.mp3");

                    //var audioplay = Instance.AddComponent<AudioSource>();
                    //audioplay.PlayOneShot(equipsound);

                    //var AS = Instance.AddComponent<AudioSource>();
                    if (!(Instance.GetComponent<HasBeenSpawned>()))
                    {
                        Instance.AddComponent<HasBeenSpawned>();
                    }
                    var shooter = Instance.GetComponent<ProjectileLauncherBehaviour>();
                    //fuse.AS = AS;
                    shooter.IsAutomatic = false;
                    shooter.projectileLaunchStrength = 0;
                    shooter.recoilMultiplier = .1f;
                    //shooter.audio = audioplay;
                    shooter.barrelPosition = new Vector2(47f, .5f) * ModAPI.PixelSize;

                    shooter.OnLaunch += (sender, projectile) =>
                    {
                        var hitboxes = projectile.GetComponents<Collider2D>();
                        foreach (Collider2D box in hitboxes)
                        {
                            Destroy(box);
                        }

                        projectile.GetComponent<SpriteRenderer>().sprite = Assets.RocketLaunch;

                        var newBox = projectile.AddComponent<BoxCollider2D>();
                        newBox.size = new Vector2(40f, 7f) * ModAPI.PixelSize;
                        projectile.AddComponent<RocketLaunch>();
                        projectile.AddComponent<DebrisComponent>();
                    };


                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(10f, -4f) * ModAPI.PixelSize };
                    var prop = ModAPI.FindPhysicalProperties("Metal");
                    phys.TrueInitialMass = 1.2f;
                    phys.Properties = prop;
                }
            });
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Stick"),
    NameOverride = "Black Hole Bomb" + ModTag,
    DescriptionOverride = "Instead of blowing everything apart, it pulls everything together. The consequences are pretty.",
    CategoryOverride = ModAPI.FindCategory("Explosives"),
    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/blackholebomb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
    NameToOrderByOverride = "Roblox",
    AfterSpawn = (Instance) =>
            {
                var box = Instance.GetComponent<BoxCollider2D>();
                Destroy(box);
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/blackholebomb.png");

                var collide = Instance.AddComponent<PolygonCollider2D>();
                collide.points = new Vector2[]
                {
                        (new Vector2(-14.5f,5.5f) * ModAPI.PixelSize),
                        (new Vector2(-6.5f,5.5f) * ModAPI.PixelSize),
                        (new Vector2(-6.5f,2.5f) * ModAPI.PixelSize),
                        (new Vector2(8.5f,2.5f) * ModAPI.PixelSize),
                        (new Vector2(8.5f,5.5f) * ModAPI.PixelSize),
                        (new Vector2(10.5f,5.5f) * ModAPI.PixelSize),
                        (new Vector2(10.5f,6.5f) * ModAPI.PixelSize),
                        (new Vector2(12.5f,6.5f) * ModAPI.PixelSize),
                        (new Vector2(12.5f,5.5f) * ModAPI.PixelSize),
                        (new Vector2(14.5f,5.5f) * ModAPI.PixelSize),
                        (new Vector2(18.5f,-1.5f) * ModAPI.PixelSize),
                        (new Vector2(18.5f,-3.5f) * ModAPI.PixelSize),
                        (new Vector2(14.5f,-7.5f) * ModAPI.PixelSize),
                        (new Vector2(12.5f,-7.5f) * ModAPI.PixelSize),
                        (new Vector2(12.5f,-8.5f) * ModAPI.PixelSize),
                        (new Vector2(10.5f,-8.5f) * ModAPI.PixelSize),
                        (new Vector2(10.5f,-7.5f) * ModAPI.PixelSize),
                        (new Vector2(-6.5f,-7.5f) * ModAPI.PixelSize),
                        (new Vector2(-6.5f,-8.5f) * ModAPI.PixelSize),
                        (new Vector2(-14.5f,-8.5f) * ModAPI.PixelSize),
                        (new Vector2(-14.5f,-6.5f) * ModAPI.PixelSize),
                        (new Vector2(-16.5f,-6.5f) * ModAPI.PixelSize),
                        (new Vector2(-16.5f,3.5f) * ModAPI.PixelSize),
                        (new Vector2(-14.5f,3.5f) * ModAPI.PixelSize),
                        (new Vector2(-14.5f,5.5f) * ModAPI.PixelSize)
                };
                var equipsound = ModAPI.LoadSound("sfx/holeequip.mp3");

                //var AS = Instance.AddComponent<AudioSource>();
                //AS.PlayOneShot(equipsound);
                if (!(Instance.GetComponent<HasBeenSpawned>()))
                {
                    Instance.AddComponent<BlackHoleBomb>();
                    Instance.AddComponent<HasBeenSpawned>();
                }
                var fuse = Instance.GetComponent<BlackHoleBomb>();
                fuse.fuse = ModAPI.LoadSound("sfx/holetickloop.mp3");
                fuse.generate = ModAPI.LoadSound("sfx/holegenerateloop.mp3");
                //fuse.AS = AS;

                var phys = Instance.GetComponent<PhysicalBehaviour>();
                var prop = ModAPI.FindPhysicalProperties("Metal");
                phys.TrueInitialMass = .8f;
                phys.Properties = prop;
                var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                tempSource.PlayOneShot(equipsound);
                Destroy(tempSource, equipsound.length); phys.PlayClipOnce(equipsound);
            }
});
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Stick"),
                NameOverride = "Scatterblaster" + ModTag,
                DescriptionOverride = "Think of it as a one-handed shotgun from the future. Good against masses of enemies, especially in tight corridors.",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/scatterblaster.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                NameToOrderByOverride = "Roblox",
                AfterSpawn = (Instance) =>
                {
                    var box = Instance.GetComponent<BoxCollider2D>();
                    Destroy(box);

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/scatterblaster.png");
                    var collider = Instance.AddComponent<BoxCollider2D>();
                    collider.size = new Vector3(7f, 7f) * ModAPI.PixelSize;
                    collider.offset = new Vector3(3.5f, 1.5f) * ModAPI.PixelSize;
                    var collider1 = Instance.AddComponent<BoxCollider2D>();
                    collider1.size = new Vector3(16f, 5f) * ModAPI.PixelSize;
                    collider1.offset = new Vector3(0f, 1.5f) * ModAPI.PixelSize;
                    var collider2 = Instance.AddComponent<BoxCollider2D>();
                    collider2.size = new Vector3(2f, 8f) * ModAPI.PixelSize;
                    collider2.offset = new Vector3(-4f, -4f) * ModAPI.PixelSize;

                    var equipsound = ModAPI.LoadSound("sfx/zap.mp3");

                    //var audioplay = Instance.AddComponent<AudioSource>();
                    //audioplay.PlayOneShot(equipsound);
                    //dumb
                    //var AS = Instance.AddComponent<AudioSource>();
                    if (!(Instance.GetComponent<HasBeenSpawned>()))
                    {
                        Instance.AddComponent<ScatterBlaster>();
                        Instance.AddComponent<HasBeenSpawned>();
                    }
                    var shooter = Instance.GetComponent<ScatterBlaster>();
                    //fuse.AS = AS;
                    shooter.Recoil = .5f;
                    shooter.InaccuracyMultiplier = .02f;
                    shooter.Delay = .6f;
                    shooter.particles = new string[] { "" };
                    shooter.ProjectileType = typeof(ScatterProj);
                    shooter.clips = new AudioClip[] { };
                    //shooter.audio = audioplay;
                    shooter.barrelPosition = new Vector2(12f, 1.5f) * ModAPI.PixelSize;



                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                    phys.HoldingPositions = new Vector3[] { new Vector3(-4f, -4f) * ModAPI.PixelSize };
                    var prop = ModAPI.FindPhysicalProperties("Metal");
                    phys.TrueInitialMass = 0.5f;
                    phys.Properties = prop;

                    var tempSource = Instance.AddComponent<AudioSource>(); //a bit scuffed but it works
                    tempSource.PlayOneShot(equipsound);
                    Destroy(tempSource, equipsound.length);
                }
            });
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Revolver"),
        NameOverride = "The General's .45" + ModTag,
        DescriptionOverride = "Does 40 damage per shot.",
        CategoryOverride = ModAPI.FindCategory("Firearms"),
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/generals45.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
        NameToOrderByOverride = "Roblox",
        AfterSpawn = (Instance) =>
        {
            //This line of code sets the sprite after the gun is spawned in.
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/generals45.png");
            foreach (var coll in Instance.GetComponents<Collider2D>())
            {
                Destroy(coll);
            }
            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            var pixel = Instance.transform.Find("hammer center").gameObject;
            Destroy(pixel);
            var holder = new GameObject("center");
            holder.transform.SetParent(Instance.transform, false);
            holder.transform.localPosition = new Vector3(-5.5f * ModAPI.PixelSize, 4f * ModAPI.PixelSize);
            pixel = new GameObject("hammer");
            pixel.transform.SetParent(holder.transform, false);
            pixel.transform.localPosition = new Vector3(-.5f * ModAPI.PixelSize, .5f * ModAPI.PixelSize);
            var pSprite = pixel.AddComponent<SpriteRenderer>();
            pSprite.sprite = ModAPI.LoadSprite("sprites/generals45hammer.png");
            Destroy(Instance.GetComponent<UseEventTrigger>());

            var anim = Instance.AddComponent<GunHammerAnimate>();
            anim.hammer = pixel;
            //anim.totaltime = 1f;

            var box = Instance.AddComponent<BoxCollider2D>();
            box.size = new Vector2(11f, 2f) * ModAPI.PixelSize;
            box.offset = new Vector2(6f, 3f) * ModAPI.PixelSize;
            var box2 = Instance.AddComponent<BoxCollider2D>();
            box2.size = new Vector2(7f, 5f) * ModAPI.PixelSize;
            box2.offset = new Vector2(-2f, 2.5f) * ModAPI.PixelSize;

            var collide = Instance.AddComponent<PolygonCollider2D>();
            collide.points = new Vector2[]
            {
                        (new Vector2(-11.5f,-5f) * ModAPI.PixelSize),
                        (new Vector2(-7.5f,-5f) * ModAPI.PixelSize),
                        (new Vector2(-7.5f,-2f) * ModAPI.PixelSize),
                        (new Vector2(-5.5f,0f) * ModAPI.PixelSize),
                        (new Vector2(-5f,3f) * ModAPI.PixelSize),
                        (new Vector2(-6f,3f) * ModAPI.PixelSize),
                        (new Vector2(-8.5f,2f) * ModAPI.PixelSize),
                        (new Vector2(-9.5f,-1f) * ModAPI.PixelSize)
            };


            firearm.barrelPosition = new Vector2(11.5f, 3f) * ModAPI.PixelSize;
            //ModAPI.Notify(firearm.Cartridge.StartSpeed);
            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
            customCartridge.name = "45 Special";
            customCartridge.Damage = 40f;
            //customCartridge.StartSpeed *= 10f;
            //customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
            customCartridge.Recoil *= 0.7f;
            //customCartridge.ImpactForce *= 10f;

            firearm.Cartridge = customCartridge;

            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("sfx/general45fire.mp3"),
            };

            var phys = Instance.GetComponent<PhysicalBehaviour>();
            phys.HoldingPositions = new Vector3[] { new Vector3(-8f, -.5f) * ModAPI.PixelSize };
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Remote Mine" + ModTag,
        DescriptionOverride = "Remote Mine activating in 5...4....3...2....BOOOOOOOOOOOOOM!",
        CategoryOverride = ModAPI.FindCategory("Explosives"),
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/remotemine.png"),
        NameToOrderByOverride = "Roblox",
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/rm_remote.png");

            var box = Instance.GetComponent<BoxCollider2D>();
            box.size = new Vector2(2f, 6f) * ModAPI.PixelSize;
            box.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;

            var phys = Instance.GetComponent<PhysicalBehaviour>();
            phys.HoldingPositions = new Vector3[] { new Vector3(-1f, 0f) * ModAPI.PixelSize };
            if (!(Instance.GetComponent<HasBeenSpawned>()))
            {
                Instance.AddComponent<RemoteMine>();
                Instance.AddComponent<HasBeenSpawned>();
            }

        }
    }
);
            //            ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Stick"),
            //    NameOverride = "Red Stratobloxxer" + ModTag,
            //    DescriptionOverride = "How to rock: 1) Spawn Red Stratobloxxer. 2) Change notes using the context menu 3) Activate",
            //    CategoryOverride = ModAPI.FindCategory("Misc."),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/redstratobloxxer.png"),
            //    NameToOrderByOverride = order,
            //    AfterSpawn = (Instance) =>
            //    {
            //        var box = Instance.GetComponent<BoxCollider2D>();
            //        Destroy(box);
            //        //Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/redstratobloxxer.png");
            //        var balls = Instance.GetComponent<SpriteRenderer>();
            //        //Destroy(balls);
            //        balls.sprite = ModAPI.LoadSprite("sprites/redstratobloxxer.png");
            //        AudioSource AS = Instance.AddComponent<AudioSource>();
            //        var collider = Instance.AddComponent<BoxCollider2D>();
            //        collider.size = new Vector2(2f, 28f) * ModAPI.PixelSize;
            //        collider.offset = new Vector2(0f, 5.5f) * ModAPI.PixelSize;
            //        var collider1 = Instance.AddComponent<CapsuleCollider2D>();
            //        collider1.size = new Vector2(10f, 14f) * ModAPI.PixelSize;
            //        //collider1.radius = 10f * ModAPI.PixelSize;
            //        collider1.offset = new Vector2(0f, -12.5f) * ModAPI.PixelSize;
            //        //var collider2 = Instance.AddComponent<BoxCollider2D>();
            //        //collider2.size = new Vector2(9f, 27f) * ModAPI.PixelSize;
            //        //collider2.offset = new Vector2(-28.5f, 0f) * ModAPI.PixelSize;
            //        var guitar = Instance.GetOrAddComponent<Instrument>();
            //        guitar.chords = new AudioClip[]
            //                            {
            //                    ModAPI.LoadSound("sfx/stratoIchord.mp3"),
            //                    ModAPI.LoadSound("sfx/stratoI-VIIchord.mp3"),
            //                    ModAPI.LoadSound("sfx/stratoVchord.mp3"),
            //                    ModAPI.LoadSound("sfx/stratoV-VIIchord.mp3"),
            //                    ModAPI.LoadSound("sfx/stratoIVchord.mp3"),
            //                    ModAPI.LoadSound("sfx/stratoIIIchord.mp3")
            //    };
            //        guitar.volume = 1.5f;
            //        guitar.noteSprite = Assets.guitarNote;
            //        guitar.emitfromnote = false;
            //        guitar.emitnotes = true;
            //        //guitar.modes = new string[] //they gotta be in order otherwise they wont match up with the right crap //its kinda pointless nvm
            //        //            {
            //        //                            "f",
            //        //                            "g",
            //        //                            "h",
            //        //                            "j",
            //        //                            "k",
            //        //                            "l"
            //        //            };


            //        var phys = Instance.GetComponent<PhysicalBehaviour>();
            //        var prop = ModAPI.FindPhysicalProperties("Plastic");
            //        phys.TrueInitialMass = 1.05f;
            //        phys.Properties = prop;
            //    }
            //});
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Subspace Tripmine" + ModTag,
                    DescriptionOverride = "Once the mine stops moving, it will enter subspace and become invisible. At this point the mine is armed. Touching the mine will set it off...",
                    CategoryOverride = ModAPI.FindCategory("Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/subspacetripmine.png"),
                    NameToOrderByOverride = order,
                    AfterSpawn = (Instance) =>
                    {
                        var box = Instance.GetComponent<BoxCollider2D>();
                        Destroy(box);
                        var sprite = Instance.GetComponent<SpriteRenderer>();
                        sprite.material = colorableMaterial;
                        sprite.sprite = ModAPI.LoadSprite("sprites/subspacetripmine.png");
                        var collider = Instance.AddComponent<BoxCollider2D>();
                        collider.size = new Vector3(17f, 17f) * ModAPI.PixelSize;
                        //var AS = Instance.AddComponent<AudioSource>();
                        var fuse = Instance.GetOrAddComponent<SubspaceMine>();
                        //fuse.AS = AS;
                        fuse.calibrate = ModAPI.LoadSound("sfx/calibrate.mp3");
                        fuse.reveal = ModAPI.LoadSound("sfx/dundun.mp3");
                        //fuse.sprite = GetComponent<SpriteRenderer>();
                        //fuse.pram = (uint rayCount, Vector3 pos, float range, float force, bool createFx, bool big, float dismember, int shrapnelCount); Tuple = (2, Random.insideUnitCircle, 12f, 2f, true, false, 100f, 0);


                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        var prop = ModAPI.FindPhysicalProperties("Plastic");
                        phys.TrueInitialMass = 0.392f;
                        phys.Properties = prop;
                    }
                });

//            ModAPI.Register(
//    new Modification()
//    {
//        OriginalItem = ModAPI.FindSpawnable("Revolver"),
//        NameOverride = "Golden Gun" + ModTag,
//        DescriptionOverride = "It only needs one round. [Arsenal]",
//        CategoryOverride = ModAPI.FindCategory("Firearms"),
//        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/generals45.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
//        NameToOrderByOverride = "Roblox",
//        AfterSpawn = (Instance) =>
//        {
//            //This line of code sets the sprite after the gun is spawned in.
//            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/goldengun.png");
//            foreach (var coll in Instance.GetComponents<Collider2D>())
//            {
//                Destroy(coll);
//            }
//            //getting the FirearmBehaviour for later manipulation
//            var firearm = Instance.GetComponent<FirearmBehaviour>();
//            //var yahoo = Instance.AddComponent<GoldGunThing>();
//            var pixel = Instance.transform.Find("hammer center").gameObject;
//            Destroy(pixel);
//            var holder = new GameObject("center");
//            holder.transform.SetParent(Instance.transform, false);
//            holder.transform.localPosition = new Vector3(-9.5f * ModAPI.PixelSize, 2.5f * ModAPI.PixelSize);
//            pixel = new GameObject("hammer");
//            pixel.transform.SetParent(holder.transform, false);
//            pixel.transform.localPosition = new Vector3(-.5f * ModAPI.PixelSize, -.5f * ModAPI.PixelSize);
//            var pSprite = pixel.AddComponent<SpriteRenderer>();
//            pSprite.sprite = ModAPI.LoadSprite("sprites/goldengunhammer.png");
//            Destroy(Instance.GetComponent<UseEventTrigger>());

//            var anim = Instance.AddComponent<GunHammerAnimate>();
//            anim.hammer = pixel;
//            //anim.totaltime = 1f;

//            var box = Instance.AddComponent<BoxCollider2D>();
//            box.size = new Vector2(13f, 1f) * ModAPI.PixelSize;
//            box.offset = new Vector2(3f, 3f) * ModAPI.PixelSize;
//            var box2 = Instance.AddComponent<BoxCollider2D>();
//            box2.size = new Vector2(7f, 3f) * ModAPI.PixelSize;
//            box2.offset = new Vector2(-6f, 3f) * ModAPI.PixelSize;
//            var box3 = Instance.AddComponent<BoxCollider2D>();
//            box3.size = new Vector2(3f, 6f) * ModAPI.PixelSize;
//            box3.offset = new Vector2(-8f, -1.5f) * ModAPI.PixelSize;


//            firearm.barrelPosition = new Vector2(9.5f, 3f) * ModAPI.PixelSize;
//            //ModAPI.Notify(firearm.Cartridge.StartSpeed);
//            //creating a custom cartridge for the gun
//            Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
//            customCartridge.name = "45 Special";
//            customCartridge.Damage = 40f;
//            //customCartridge.StartSpeed *= 10f;
//            //customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
//            customCartridge.Recoil *= 0.7f;
//            //customCartridge.ImpactForce *= 10f;

//            firearm.Cartridge = customCartridge;

//            firearm.ShotSounds = new AudioClip[]
//            {
//                ModAPI.LoadSound("sfx/general45fire.mp3"),
//            };

//            var phys = Instance.GetComponent<PhysicalBehaviour>();
//            phys.HoldingPositions = new Vector3[] { new Vector3(-8f, -1f) * ModAPI.PixelSize };

//            var BallisticsEmitter = firearm.BallisticsEmitter;
//            ModAPI.Notify("test");
//            BallisticsEmitter.BulletEntryCallback = delegate(BallisticsEmitter.CallbackParams args)
//            {
//                ModAPI.Notify(args);
//                if (args.HitObject.gameObject.GetComponent<LimbBehaviour>())
//                {
//                    ModAPI.Notify("3");
//                    var hitLimb = args.HitObject.gameObject.GetComponent<LimbBehaviour>();
//                    foreach (LimbBehaviour limb in hitLimb.Person.Limbs)
//                    {
//                        limb.Frozen = true;
//                        limb.Color = Color.yellow;
//                    }
//                }
//            };
//            ModAPI.Notify("yay");

//            //firearm.WHY();

//            //Instance.AddComponent<GoldenGun>();
//        }
//    }
//);
            //        ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Stick"),
            //    NameOverride = "Grapple Hook" + ModTag,
            //    DescriptionOverride = "balls",
            //    CategoryOverride = ModAPI.FindCategory("Ranged"),
            //    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/subspacetripmine.png"),
            //    NameToOrderByOverride = order,
            //    AfterSpawn = (Instance) =>
            //    {
            //        var box = Instance.GetComponent<BoxCollider2D>();
            //        Destroy(box);
            //        var sprite = Instance.GetComponent<SpriteRenderer>();
            //        sprite.sprite = ModAPI.LoadSprite("sprites/grapplehook.png");
            //        var collider = Instance.AddComponent<BoxCollider2D>();
            //        collider.size = new Vector3(13f, 5f) * ModAPI.PixelSize;
            //        collider.offset = new Vector3(-11f, 1f) * ModAPI.PixelSize;
            //        var collider1 = Instance.AddComponent<BoxCollider2D>();
            //        collider1.size = new Vector3(13f, 5f) * ModAPI.PixelSize;
            //        collider1.offset = new Vector3(2.5f, 1f) * ModAPI.PixelSize;
            //        var collider2 = Instance.AddComponent<BoxCollider2D>();
            //        collider2.size = new Vector3(3f, 6f) * ModAPI.PixelSize;
            //        collider2.offset = new Vector3(-11f, -4.5f) * ModAPI.PixelSize;

            //        var AS = Instance.AddComponent<AudioSource>();

            //        var grapHook = Instance.GetOrAddComponent<Grapplehook>();
            //                //fuse.AS = AS;
            //                grapHook.audio = AS;
            //                //grapHook.clips =
            //                grapHook.barrelPosition = new Vector3(13.5f, 1f) * ModAPI.PixelSize;
            //        grapHook.normaltex = sprite.sprite;
            //        grapHook.shottex = ModAPI.LoadSprite("sprites/grapple.png");
            //        grapHook.hooktex = ModAPI.LoadSprite("sprites/hook.png");
            //                //fuse.sprite = GetComponent<SpriteRenderer>();
            //                //fuse.pram = (uint rayCount, Vector3 pos, float range, float force, bool createFx, bool big, float dismember, int shrapnelCount); Tuple = (2, Random.insideUnitCircle, 12f, 2f, true, false, 100f, 0);


            //                var phys = Instance.GetComponent<PhysicalBehaviour>();
            //        var prop = ModAPI.FindPhysicalProperties("Plastic");
            //        phys.TrueInitialMass = 0.392f;
            //        phys.Properties = prop;
            //    }
            //});
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Taser" + ModTag,
        DescriptionOverride = "One of the default items of a Police Officer. [Jailbreak]",
        CategoryOverride = ModAPI.FindCategory("Firearms"),
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/taser.png"),
        NameToOrderByOverride = order,
        AfterSpawn = (Instance) =>
        {
            var box = Instance.GetComponent<BoxCollider2D>();
            Destroy(box);
            var sprite = Instance.GetComponent<SpriteRenderer>();
            sprite.sprite = ModAPI.LoadSprite("sprites/tazer.png");
            var collider = Instance.AddComponent<PolygonCollider2D>();
            collider.points = new Vector2[]
                {
                                (new Vector2(-6.5f,-2.5f) * ModAPI.PixelSize),
                                (new Vector2(-6.5f,-.5f) * ModAPI.PixelSize),
                                (new Vector2(-2f,2.5f) * ModAPI.PixelSize),
                                (new Vector2(5f,2.5f) * ModAPI.PixelSize),
                                (new Vector2(6f,1.5f) * ModAPI.PixelSize),
                                (new Vector2(6f,-1.5f) * ModAPI.PixelSize),
                                (new Vector2(5f,-2.5f) * ModAPI.PixelSize),
                                (new Vector2(0f,-.5f) * ModAPI.PixelSize),
                                (new Vector2(-3f,-2.5f) * ModAPI.PixelSize)
                };
            //var AS = Instance.AddComponent<AudioSource>();
            var elec = Instance.GetOrAddComponent<JBTaser>();
            elec.barrelPosition = new Vector2(6f, 0f) * ModAPI.PixelSize;
            //elec.AudioPlayer = Instance.GetComponent<AudioSource>();
            //fuse.AS = AS
            //fuse.sprite = GetComponent<SpriteRenderer>();
            //fuse.pram = (uint rayCount, Vector3 pos, float range, float force, bool createFx, bool big, float dismember, int shrapnelCount); Tuple = (2, Random.insideUnitCircle, 12f, 2f, true, false, 100f, 0);


            var phys = Instance.GetComponent<PhysicalBehaviour>();
            var prop = ModAPI.FindPhysicalProperties("Plastic");
            phys.TrueInitialMass = 0.392f;
            phys.Properties = prop;
        }
    });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                NameOverride = "Knife" + ModTag,
                DescriptionOverride = "Don't get shot by the sheriff. [Murder Mystery]",
                CategoryOverride = ModAPI.FindCategory("Melee"),
                ThumbnailOverride = ModAPI.LoadSprite("thumbnails/knife.png"),
                NameToOrderByOverride = order,
                AfterSpawn = (Instance) =>
                {
                    var sprite = Instance.GetComponent<SpriteRenderer>();

                    
                    var phys = Instance.GetComponent<PhysicalBehaviour>();
                   // if (!Instance.GetComponent<HasBeenSpawned>())
                    //{
                        sprite.sprite = ModAPI.LoadSprite("sprites/knife.png");
                        var random = Instance.GetOrAddComponent<RandomSpriteBehaviour>();
                        random.PickRandomOnStart = false;
                        random.sprites = new Sprite[] { 
                        ModAPI.LoadSprite("sprites/knife.png"),
                        ModAPI.LoadSprite("sprites/whiteoutknife.png"),
                        ModAPI.LoadSprite("sprites/linkedknife.png"),
                        ModAPI.LoadSprite("sprites/knifepencilskin.png"),
                        ModAPI.LoadSprite("sprites/loveknife.png"),
                        ModAPI.LoadSprite("sprites/bluesteelknife.png"),
                        ModAPI.LoadSprite("sprites/limeknife.png")
                        };
                       // Instance.AddComponent<HasBeenSpawned>();
                   // }
                    //phys.HoldingPositions = new Vector3[] { new Vector3(0f, -18.5f) * ModAPI.PixelSize };

                    //phys.Properties = Instantiate(phys.Properties);
                    //phys.Properties.StabSound = new AudioClip[] { ModAPI.LoadSound("sfx/mmstab.mp3") };
                    //phys.Properties.HardImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordlunge.mp3") };
                    //phys.Properties.SoftImpact = new AudioClip[] { ModAPI.LoadSound("sfx/swordslash.mp3") };


                    //var equipsound = ModAPI.LoadSound("sfx/unsheath.mp3");

                    

                    //var audioplay = Instance.AddComponent<AudioSource>();
                    var stabby = Instance.GetOrAddComponent<StabSound>();
                    //stabby.audio = audioplay;
                    stabby.sound = ModAPI.LoadSound("sfx/mmstab.mp3");
                    //audioplay.PlayOneShot(equipsound);


                }
            });

            #endregion
        }
    }

    internal class CreateHat
    {
        public GameObject hatObject;
        public CreateHat(Transform parentPart, Sprite hatSprite, Vector3 offset, Quaternion tilt)
        {
            hatObject = new GameObject("Hat");
            hatObject.AddComponent<SpriteRenderer>().sprite = hatSprite;
            hatObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
            hatObject.GetComponent<SpriteRenderer>().material = Mod.colorableMaterial;
            hatObject.transform.SetParent(parentPart);
            hatObject.transform.localPosition = offset;
            hatObject.transform.localRotation = tilt;
            hatObject.transform.localScale = new Vector3(1f, 1f);
            hatObject.AddComponent<RotHat>();
        }
    }

    //public delegate void goldguneffect(BallisticsEmitter.CallbackParams args);

    #region behaviours

    //public class GoldGunThing : MonoBehaviour
    //{
    //public delegate void Effect = (BallisticsEmitter.CallbackParams args) =>
    //{
    //        if (args.HitObject.gameObject.GetComponent<LimbBehaviour>())
    //        {
    //            var hitLimb = args.HitObject.gameObject.GetComponent<LimbBehaviour>();
    //            foreach (LimbBehaviour limb in hitLimb.Person.Limbs)
    //            {
    //                limb.Frozen = true;
    //                limb.Color = Color.yellow;
    //            }
    //}
    // }



    //
    public class StabSound : MonoBehaviour, Messages.ILodged
    {
        //[SkipSerialisation]
        //public AudioSource audio;
        [SkipSerialisation]
        public AudioClip sound;
        public void Lodged(Stabbing stabbing)
        {
            gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(sound);
        }
    }

    public class JBTaser : MonoBehaviour, Messages.IUse
    {
        //[SkipSerialisation]
        //public AudioClip useSound;
        //[SkipSerialisation]
        //private PhysicalBehaviour phys;
        [SkipSerialisation]
        public float Range = 2050f;
        [SkipSerialisation]
        public float delay = 3f;
        [SkipSerialisation]
        public bool debounce = false;
        [SkipSerialisation]
        public Vector2 barrelPosition;
        [SkipSerialisation]
        public Vector2 barrelDirection = Vector2.right;
        [SkipSerialisation]
        private LineRenderer line;
        private Vector2 BarrelPosition
        {
            get
            {
                if (!gameObject.GetComponent<PhysicalBehaviour>().rigidbody)
                {
                    return base.transform.TransformPoint(barrelPosition * base.transform.lossyScale);
                }

                return gameObject.GetComponent<PhysicalBehaviour>().rigidbody.GetRelativePoint(barrelPosition * base.transform.lossyScale);
            }
        }

        private Vector2 BarrelDirection => (gameObject.GetComponent<PhysicalBehaviour>().rigidbody ? gameObject.GetComponent<PhysicalBehaviour>().rigidbody.GetRelativeVector(barrelDirection) : ((Vector2)base.transform.TransformDirection(barrelDirection))) * ((!IsFlipped) ? 1 : (-1));
        //[SkipSerialisation]
        //public Vector2 BarrelDirection;

        private bool IsFlipped => base.transform.localScale.x < 0f;

        void FixedUpdate()
        {
            if (line)
            {
                line.SetPosition(0, BarrelPosition);
            }
        }
        public void Use(ActivationPropagation activation)
        {
            if (!line)
            {
                gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(Assets.JBTaserSound);
                var hits = new System.Collections.Generic.List<Utils.LaserHit>();
                //ModAPI.Notify("balls");
                //var ray = Utils.MaterialAwareRaycast(gameObject.transform.position, gameObject.transform.right, distance * ModAPI.PixelSize, LayerMask.GetMask("Objects", "Bounds", "Debris"), 16);

                //ModAPI.Notify("balls.1");
                Vector3[] vertices;
                line = gameObject.AddComponent<LineRenderer>();
                //line.alignment = LineAlignment.View;
                line.startWidth = ModAPI.PixelSize;
                line.endWidth = ModAPI.PixelSize;
                line.useWorldSpace = true;
                line.material = ModAPI.FindMaterial("Sprites-Default");
                line.startColor = new Color(0f, .2f, .6f, 1f);
                line.endColor = new Color(0f, .2f, .6f, 1f);
                Vector2 vector = BarrelPosition;
                Vector2 vector2 = BarrelDirection;
                Utils.GetLaserEndPoint(vector, vector2, ref hits, LayerMask.GetMask("Objects", "Bounds", "Debris"), Range);
                if (hits.Count != 0)
                {
                    vertices = new Vector3[hits.Count + 1];
                    vertices[0] = vector;
                    line.positionCount = hits.Count + 1;
                    for (int i = 0; i < hits.Count; i++)
                    {
                        vertices[i + 1] = hits[i].point;
                        var limb = hits[i].hit.Value.collider.gameObject.GetComponent<LimbBehaviour>();
                        if (limb)
                        {
                            var con = limb.Person.Consciousness;
                            if (limb.Person.Consciousness > .8f)
                            {
                                StartCoroutine(trip());
                                IEnumerator trip()
                                {
                                    limb.Person.Consciousness = 0f;
                                    yield return new WaitForSeconds(3f);
                                    limb.Person.Consciousness = con;
                                }
                            }
                        }
                    }
                    StartCoroutine(trace());
                    IEnumerator trace()
                    {
                        line.SetPositions(vertices);
                        yield return new WaitForSeconds(.1f);
                        Destroy(line);
                    }
                }
            }
        }
    }
    public class SubspaceMine : MonoBehaviour, Messages.IUse, Messages.IOnEMPHit, Messages.IShot
    {
        //var AS = gameObject.GetComponent<AudioSource>();
        //AudioSource AS;
        [SkipSerialisation]
        public AudioClip calibrate;
        [SkipSerialisation]
        public AudioClip reveal;
        //public Vector3 test;
        [SkipSerialisation]
        public bool debounce = false;
        public bool calibrated = false;
        [SkipSerialisation]
        public Vector3 beginpos;
        [SkipSerialisation]
        public Vector3 endpos;
        [SkipSerialisation]
        SpriteRenderer sprite;
        //public Tuple pram;
        //public struct parameters{(uint rayCount, Vector3 pos, float range, float force, bool createFx, bool big, float dismember, int shrapnelCount) Tuple = (2, Vec, 12f, 2f, true, false, 100f, 0); };
        //public static void parameters;
        //public AudioClip explode;

        public void Start()
        {
            sprite = GetComponent<SpriteRenderer>();
            if (calibrated)
            {
                sprite.color = new Color(1f, 1f, 1f, 0f);
                calibrated = false;
                StartCoroutine(Spawned());
            }
        }

        public IEnumerator Spawned()
        {
            yield return new WaitForSeconds(.2f);
            calibrated = true;
            //return Spawned();
        }

        public void Use(ActivationPropagation activation)
        {
            if (!(debounce))
            {
                debounce = true;
                //AudioSource AS = gameObject.GetComponent<AudioSource>();
                //var sprite = gameObject.GetComponent<SpriteRenderer>();
                //ModAPI.Notify(sprite);
                StartCoroutine(Calibrate());
                IEnumerator Calibrate()
                {
                    while (!(calibrated))
                    {
                        beginpos = gameObject.transform.position;
                        gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(calibrate);
                        yield return new WaitForSeconds(1f);
                        gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(calibrate);
                        yield return new WaitForSeconds(1f);
                        endpos = gameObject.transform.position;
                        if (beginpos == endpos)
                        {
                            calibrated = true;
                            for (double i = 1; i > 0; i -= .1)
                            {
                                sprite.color = new Color(1f, 1f, 1f, System.Convert.ToSingle(i));
                                yield return new WaitForSeconds(.05f); //just kinda adapting roblox code into c#
                            }
                            Invis();
                        }
                    }
                }
            }
        }

        public void Invis()
        {
            //AudioSource AS = gameObject.GetComponent<AudioSource>();
            //var sprite = gameObject.GetComponent<SpriteRenderer>();
            StartCoroutine(Pulse());
            IEnumerator Pulse()
            {
                while (calibrated)
                {
                    var rnd = new System.Random();
                    var number = rnd.Next(1, 21);
                    yield return new WaitForSeconds(number);
                    gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(reveal);
                    for (double i = 1; i > 0; i -= .1)
                    {
                        //sprite.sprite = Assets.bubble1;
                        sprite.color = new Color(1f, 1f, 1f, System.Convert.ToSingle(i));
                        yield return new WaitForSeconds(.05f);
                    }
                    for (double i = 0; i < 1; i += 1)
                    {
                        sprite.color = new Color(1f, 1f, 1f, System.Convert.ToSingle(i));
                        yield return new WaitForSeconds(.05f);
                    }

                }
            }
        }
        public void Explode()
        {
            var expl = ModAPI.CreateParticleEffect("PinkExplosion", transform.position);
            expl.GetComponent<ExplosionSoundBehviour>().Near = new AudioClip[] { Assets.SubspaceExplosion};
            //ModAPI.Notify(expl.GetComponent<ExplosionSoundBehviour>().audioSource.volume);
            expl.GetComponent<ExplosionSoundBehviour>().audioSource.volume = 1;
            //expl.GetComponent<ExplosionSoundBehviour>().Near = new AudioClip[] { Assets.R80Explosion };
            //visual.GetComponent<AudioSource>().clip = 
            ExplosionCreator.CreateFragmentationExplosion(new ExplosionCreator.ExplosionParameters
            {
                Position = gameObject.transform.position,
                CreateParticlesAndSound = false,
                EffectSize = ExplosionCreator.EffectSize.Small,
                DismemberChance = .5f,
                FragmentForce = 12,
                FragmentationRayCount = 32,
                Range = 12f * 16f * ModAPI.PixelSize
            });
            Destroy(gameObject);
        }
        public void OnCollisionEnter2D()
        {
            if (calibrated)
            {
                Explode();
            }
        }
        public void Shot(Shot shot)
        {
            if (calibrated)
            {
                Explode();
            }
        }
        public void OnEMPHit()
        {
            var sprite = gameObject.GetComponent<SpriteRenderer>();
            StartCoroutine(Visible());
            IEnumerator Visible()
            {
                for (double i = 0; i < 1; i += .1)
                {
                    sprite.color = new Color(1f, 1f, 1f, System.Convert.ToSingle(i));
                    yield return new WaitForSeconds(.05f);
                }
            }
            calibrated = false;
            debounce = false;
        }

    }
    public class GoUpBehaviour : MonoBehaviour
    {
        [SkipSerialisation]
        public float speed;
        [SkipSerialisation]
        public float lifetime;
        [SkipSerialisation]
        float timer = 0;
        void Update()
        {
            timer += Time.deltaTime;
            this.transform.position += this.transform.up * speed * Time.deltaTime;
            if (timer > lifetime)
            {
                Destroy(gameObject);
            }
        }
    }

    public class Instrument : MonoBehaviour, Messages.IUse
    {
        public int mode = 0;
        [SkipSerialisation]
        public AudioClip[] chords;
        [SkipSerialisation]
        public float volume;
        [SkipSerialisation]
        public Sprite noteSprite;
        [SkipSerialisation]
        public bool emitfromnote;
        [SkipSerialisation]
        public bool emitnotes;
        [SkipSerialisation]
        public float angleLimit = 5f;

        private void Awake()
        {
            PhysicalBehaviour phys = GetComponent<PhysicalBehaviour>();

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("Next mode", "Next mode", "Changes the mode to the next mode.", () =>
            {
                mode += 1;
                if (mode == chords.Length)
                {
                    mode = 0;
                }
                ModAPI.Notify("Mode is now set to " + mode);
            }));
        }

        public void Use(ActivationPropagation activation)
        {
            if (emitnotes == true)
            {
                var note = new GameObject();
                note.AddComponent<Rigidbody2D>();
                note.transform.position = gameObject.transform.position;
                var sprite = note.AddComponent<SpriteRenderer>();
                sprite.sprite = noteSprite;
                var randotate = UnityEngine.Random.Range(-angleLimit, angleLimit);
                note.transform.rotation = Quaternion.Euler(0, 0, randotate);

                var goUp = note.AddComponent<GoUpBehaviour>();
                goUp.speed = 18f;
                goUp.lifetime = 5f;
                if (emitfromnote)
                {
                    AudioSource AS = note.GetComponent<AudioSource>();
                    AS.PlayOneShot(chords[mode], volume);
                }
            }
            if (!(emitfromnote))
            {
                AudioSource AS = GetComponent<AudioSource>();
                AS.PlayOneShot(chords[mode], volume);
            }
        }
    }
    class RemoteMine : MonoBehaviour
    {
        [SkipSerialisation]
        GameObject Mine;
        [SkipSerialisation]
        float timer = 0;

        public void Use()
        {
            if (Mine != null)
            {
                Explode();
                return;
            }
            Mine = ModAPI.CreatePhysicalObject("Mine", Assets.rm_Mine);
            var box = Mine.GetComponent<BoxCollider2D>();
            box.size = new Vector2(5f, 2f) * ModAPI.PixelSize;
            box.offset = new Vector2(0f, -1.5f) * ModAPI.PixelSize;
            Mine.transform.position = transform.position;
            Mine.GetComponent<PhysicalBehaviour>().TrueInitialMass = .01f;
            Mine.AddComponent<DebrisComponent>();
            Mine.AddComponent<Optout>();
            //var audio = Mine.AddComponent<AudioSource>();
            //audio.outputAudioMixerGroup = Global.main.SoundEffects;
            //audio.gameObject.
            //audio.PlayOneShot(Assets.remoteNoise);
            //audio.clip = Assets.mineNoise;
            //audio.volume = 1f;
            //audio.loop = true;
            //audio.Play();
            gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(Assets.remoteNoise);
        }

        void Update()
        {
            timer += Time.deltaTime;
            if (timer > Assets.mineNoise.length)
            {
                Mine.GetComponent<PhysicalBehaviour>().PlayClipOnce(Assets.mineNoise);
                timer = 0;
            }
            

        }
            public void Explode()
        {
            var expl = ModAPI.CreateParticleEffect("Explosion", Mine.transform.position);
            expl.GetComponent<ExplosionSoundBehviour>().Near = new AudioClip[] { Assets.RemoteExplosion };
            ExplosionCreator.CreateFragmentationExplosion(new ExplosionCreator.ExplosionParameters
            {
                Position = Mine.transform.position,
                CreateParticlesAndSound = false,
                EffectSize = ExplosionCreator.EffectSize.Medium,
                DismemberChance = .75f,
                FragmentForce = 12,
                FragmentationRayCount = 32,
                Range = 12f * 12f * ModAPI.PixelSize
            });
            Destroy(Mine);
        }
    }
    class ScatterProj : MonoBehaviour
    {
        //[SkipSerialisation]
        //TrailRenderer trail;
        [SkipSerialisation]
        public float speed = 1.5f;
        [SkipSerialisation]
        float timer = 4f;
        [SkipSerialisation]
        readonly bool closing;
        [SkipSerialisation]
        Vector3 pos;
        //[SkipSerialisation]
        //LayerMask layers;
        [SkipSerialisation]
        float hits = 7f;

        void Awake()
        {

            gameObject.AddComponent<Rigidbody2D>();
            var sprite = gameObject.AddComponent<SpriteRenderer>();
            sprite.sprite = Assets.scatterBlast;

            var box = gameObject.AddComponent<BoxCollider2D>();
            box.size = new Vector2(6f, 3f) * ModAPI.PixelSize;

            //layers = LayerMask.GetMask("Objects", "Bounds", "Debris");

            gameObject.SetLayer(LayerMask.NameToLayer("Objects"));

            //var Mat = new PhysicsMaterial2D();
            //Mat.friction = .25f;
            //Mat.bounciness = .5f;

            var phys = gameObject.AddComponent<PhysicalBehaviour>();
            phys.AbsorbsLasers = true;
            //phys.Properties.PhysicMaterial = Mat;
            phys.TrueInitialMass = .004f;
            phys.Properties = Instantiate(ModAPI.FindPhysicalProperties("Metal"));
            phys.Properties.HardImpact = new AudioClip[] { Assets.projHit };
            phys.Properties.SoftImpact = new AudioClip[] { Assets.projHit };

            gameObject.AddComponent<DebrisComponent>();
        }

        void Start()
        {
            var rb = gameObject.GetComponent<Rigidbody2D>();
            rb.AddForce(transform.right * speed);
        }

        void Update()
        {
            GetComponent<PhysicalBehaviour>().Temperature = 400f;
            timer -= Time.deltaTime;
            if (timer < 0f)
            {
                Destroy(gameObject);
            }
        }
        public void OnCollisionEnter2D()
        {

            hits -= 1;
            if (hits < 0f)
            {
                Destroy(gameObject);
            }
        }
    }
    class ScatterBlaster : CanShoot
    {
        [SkipSerialisation]
        public float Recoil;
        [SkipSerialisation]
        public float InaccuracyMultiplier;
        [SkipSerialisation]
        public float Delay;
        [SkipSerialisation]
        public string[] particles;
        [SkipSerialisation]
        public Type ProjectileType;

        //[SkipSerialisation]
        //public AudioSource audio;
        [SkipSerialisation]
        public AudioClip[] clips;

        [SkipSerialisation]
        public Vector2 barrelPosition = new Vector2(0f, 0f);
        [SkipSerialisation]
        public Vector2 barrelDirection = Vector2.right;
        [SkipSerialisation]
        float t = 0f;
        [SkipSerialisation]
        public float reloadTime = 0f;

        void Use()
        {
            Shoot();
        }

        void UseContinuous()
        {
            if (t > Delay)
            {
                Shoot();
            }
        }

        void Update()
        {
            t += Time.deltaTime;
        }

        public override void Shoot()
        {

            //audio.pitch = UnityEngine.Random.Range(0.75f, 1.25f); //This is just for variety, it's not required.
            if (clips.Length > 0)
            {
                gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(clips[0]);
            }
            t = 0f;
            GetComponent<PhysicalBehaviour>().rigidbody.AddForceAtPosition(BarrelDirection * -this.Recoil, BarrelPosition, ForceMode2D.Impulse);

            var bolt = new GameObject("bolt", ProjectileType);
            bolt.transform.position = BarrelPosition;
            bolt.transform.right = BarrelDirection;
            var bolt2 = new GameObject("bolt", ProjectileType);
            bolt2.transform.position = BarrelPosition + Vector2.Perpendicular(BarrelDirection).normalized * .5f;
            bolt2.transform.right = BarrelDirection;
            var bolt3 = new GameObject("bolt", ProjectileType);
            bolt3.transform.position = BarrelPosition - Vector2.Perpendicular(BarrelDirection).normalized * .5f;
            bolt3.transform.right = BarrelDirection;

            for (int i = 0; i < particles.Length; i++)
            {
                ModAPI.CreateParticleEffect(particles[i], BarrelPosition);
            }
            if (reloadTime > 0f)
            {
                StartCoroutine(reload()); //for things that make a reload sound.
                IEnumerator reload()
                {
                    yield return new WaitForSeconds(reloadTime);
                    gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(clips[1]);
                }

            }
        }

        public override Vector2 BarrelPosition => transform.TransformPoint(barrelPosition);
        public Vector2 BarrelDirection => transform.TransformDirection(barrelDirection) * transform.localScale.x;

    }
    public class BlackHoleBomb : MonoBehaviour, Messages.IUse
    {
        //var AS = gameObject.GetComponent<AudioSource>();
        //AudioSource AS;
        //[SkipSerialisation]
        //public AudioSource AS;
        [SkipSerialisation]
        public AudioClip fuse;
        [SkipSerialisation]
        public AudioClip generate;
        [SkipSerialisation]
        bool debounce = false;
        [SkipSerialisation]
        bool exploding = false;
        [SkipSerialisation]
        float timer = 0f;
        GameObject hat;
        //public AudioClip explode;

        //void Start()
        //{
        //    AS = gameObject.GetComponent<AudioSource>();
        //}
        public void Use(ActivationPropagation activation)
        {
            //AudioSource AS = gameObject.GetComponent<AudioSource>();
            gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(fuse);
            //AS.PlayOneShot(fuse);
            StartCoroutine(FUSE());
            IEnumerator FUSE()
            {
                if (!(debounce))
                {
                    debounce = true;
                    yield return new WaitForSeconds(9);
                    exploding = true;
                    hat = new GameObject();
                    hat.transform.SetParent(gameObject.transform);
                    hat.transform.localPosition = new Vector3(0f, 0f) * ModAPI.PixelSize;
                    hat.transform.localRotation = Quaternion.Euler(0, 0, 0);
                    hat.transform.localScale = new Vector3(1f, 1f);
                    var hatsprite = hat.GetOrAddComponent<SpriteRenderer>();
                    hatsprite.sprite = Assets.blackholeCircle;
                    hatsprite.sortingLayerName = "Bottom";
                    gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(generate);
                    //AS.PlayOneShot(generate);
                }
            }


        }
        void Update()
        {
            if (exploding)
            {
                timer += Time.deltaTime;
                var ray = Physics2D.OverlapCircleAll(transform.position, 250f * ModAPI.PixelSize, LayerMask.GetMask("Objects", "Bounds", "Debris"));
                foreach (Collider2D collider in ray)
                {
                    var distance = transform.position - collider.transform.position;
                    distance.Normalize();
                    Vector2 velo = distance * 8 * Time.deltaTime;
                    collider.attachedRigidbody.velocity += velo;
                }
                if (timer > 10)
                {
                    Destroy(hat);
                    Destroy(gameObject);
                }
            }
        }

    }
    class Grapplehook : MonoBehaviour
    {

        [SkipSerialisation]
        public AudioSource audio;
        [SkipSerialisation]
        public AudioClip[] clips;

        [SkipSerialisation]
        public Vector3 barrelPosition = new Vector2(0f, 0f);
        [SkipSerialisation]
        public Vector3 barrelDirection = Vector2.right;
        [SkipSerialisation]
        float t = 0f;
        [SkipSerialisation]
        public float reloadTime = 0f;
        [SkipSerialisation]
        readonly bool released = false;
        [SkipSerialisation]
        public Sprite normaltex;
        [SkipSerialisation]
        public Sprite shottex;
        [SkipSerialisation]
        public Sprite hooktex;
        [SkipSerialisation]
        private GameObject hook;
        [SkipSerialisation]
        LineRenderer line;
        [SkipSerialisation]
        readonly bool grappled = false;
        [SkipSerialisation]
        NoCollide noCol;
        [SkipSerialisation]
        PersonBehaviour holder;

        void Start()
        {
            noCol = gameObject.AddComponent<NoCollide>();
            noCol.NoCollideSetA = gameObject.GetComponents<Collider2D>();
        }
        void Use()
        {
            if (released)
            {
                UnShoot();
                Shoot();
            }
            else
            {
                Shoot();
            }
        }


        void Update()
        {
            t += Time.deltaTime;
            if (hook)
            {
                var points = new Vector3[] { transform.TransformPoint(barrelPosition - new Vector3(4f * ModAPI.PixelSize,0)), hook.transform.TransformPoint(new Vector3(4f * ModAPI.PixelSize, 0)) };
                line.SetPositions(points);
                if (hook.GetComponent<HookBehaviour>().grappled == true)
                {
                    
                    //var FUCK = gameObject.transform.position - hookObject.transform.position;
                    if (Vector3.Distance(hook.transform.position, gameObject.transform.TransformPoint(barrelPosition - new Vector3(4f * ModAPI.PixelSize, 0))) > 15 * ModAPI.PixelSize)
                    {
                        gameObject.GetComponent<Rigidbody2D>().velocity = 10 * (hook.transform.position - gameObject.transform.position).normalized;
                    }
                    else
                    {
                        gameObject.GetComponent<Rigidbody2D>().velocity = -Physics2D.gravity;
                    }
                }
            }
        }

        public void OnGripped(GripBehaviour gripper)
        {
            holder = gripper.gameObject.GetComponent<LimbBehaviour>().Person;
        }
        public void OnDrop()
        {
            holder = null;
        }
        public void UnShoot()
        {

        }
        public void Shoot()
        {  
            gameObject.GetComponent<SpriteRenderer>().sprite = shottex;
            //hook = new GameObject("Hook", typeof(HookBehaviour));
            hook = ModAPI.CreatePhysicalObject("Hook", hooktex);
            //hook.AddComponent<Rigidbody2D>();
            //hook.GetComponent<Rigidbody2D>().simulated = true;
            //hook.AddComponent<PhysicalBehaviour>();
            //hook.AddComponent<BoxCollider2D>().size = new Vector2(8f, 15f) * ModAPI.PixelSize;
            //hook.AddComponent<SpriteRenderer>().sprite = hooktex;
            //hook.GetComponent<SpriteRenderer>().flipX = transform.localScale.x < 0;
            hook.GetComponent<PhysicalBehaviour>().RefreshOutline();
            noCol.NoCollideSetB = new Collider2D[] { hook.GetComponent<BoxCollider2D>()};
            
            hook.transform.localScale = gameObject.transform.localScale;
            hook.transform.position = transform.TransformPoint(barrelPosition);
            hook.transform.right = transform.TransformDirection(barrelDirection) * transform.localScale.x; 
            var behave = hook.AddComponent<HookBehaviour>();
            behave.owner = gameObject;
            line = gameObject.AddComponent<LineRenderer>();
            line.alignment = LineAlignment.View;
            line.startWidth = ModAPI.PixelSize;
            line.endWidth = ModAPI.PixelSize;
            line.useWorldSpace = true;
            line.material = ModAPI.FindMaterial("Sprites-Default");
            var points = new Vector3[] { gameObject.transform.right, hook.transform.position };
            line.SetPositions(points);
            line.startColor = new Color(0f, 0f, 0f, 1f);
            line.endColor = new Color(0f, 0f, 0f, 1f);
        }

    }

    public class GunHammerAnimate : MonoBehaviour, Messages.IUse
    {
        [SkipSerialisation]
        public float totaltime = .01f;
        [SkipSerialisation]
        public GameObject hammer;
        [SkipSerialisation]
        bool beingUsed = false;
        public void Use(ActivationPropagation activation)
        {
            GameObject holder = hammer.transform.parent.gameObject;
            if (beingUsed == false)
            {
                StartCoroutine(yo());
                IEnumerator yo()
                {
                    beingUsed = true;
                    for (int i = 0; i < 10; i++)
                    {
                        yield return new WaitForSeconds(totaltime / 20);
                        hammer.transform.RotateAround(holder.transform.position, new Vector3(0, 0, 1), -9 *gameObject.transform.localScale.x);
                    }
                    for (int i = 0; i < 10; i++)
                    {
                        yield return new WaitForSeconds(totaltime / 20);
                        hammer.transform.RotateAround(holder.transform.position, new Vector3(0, 0, 1), 9 * gameObject.transform.localScale.x);
                    }
                    beingUsed=false;
                }
            }
           
            

        }
    }

    public class HookBehaviour : MonoBehaviour
    {
        [SkipSerialisation]
        readonly float maxDist = 30f;
        [SkipSerialisation]
        public GameObject owner;
        [SkipSerialisation]
        public float speed = 10f;
        [SkipSerialisation]
        public bool grappled = false;
        [SkipSerialisation]
        bool closing;
        [SkipSerialisation]
        Vector3 dir;
        [SkipSerialisation]
        Vector3 pos;
        [SkipSerialisation]
        LayerMask layers;

        void Start()
        {

        }

        void LateUpdate()
        {
            if (!grappled)
            {
                gameObject.GetComponent<Rigidbody2D>().velocity = dir;
                var distance = speed * Time.deltaTime;
                if (distance > maxDist)
                {
                    this.closing = true;
                }
                if (closing)
                {
                    //trail.autodestruct = true;
                    Destroy(gameObject);
                    return;
                }

                pos = transform.position;
                dir = transform.right;
            }
            else
            {
                gameObject.GetComponent<Rigidbody2D>().velocity = -Physics2D.gravity;
            }
        }
        private void OnCollisionEnter2D(Collision2D hit)
        {
            //Vector2 normal = hit.point;
            if (hit.gameObject != owner) {
                this.closing = true;
                this.grappled = true;
                var connection = gameObject.AddComponent<FixedJoint2D>();
                connection.connectedBody = hit.rigidbody;
                connection.anchor = hit.GetContact(0).point;
                connection.connectedAnchor = hit.GetContact(0).point;
                connection.breakForce = Mathf.Infinity;
                connection.breakTorque = Mathf.Infinity;
                connection.frequency = 0;
                connection.dampingRatio = .9f;
            }
            
        }
    }
    class RocketLaunch : MonoBehaviour, Messages.IShot
    {
        //[SkipSerialisation]
        //TrailRenderer trail;
        [SkipSerialisation]
        readonly float speed = 10;
        [SkipSerialisation]
        public Vector3 dir;
        [SkipSerialisation]
        Vector3 targetDir;
        [SkipSerialisation]
        bool closing;
        [SkipSerialisation]
        float longtimer = 0;
        [SkipSerialisation]
        float timer = 0;


        void Awake()
        {
            //ModAPI.Notify("help");
        }
        void Update()
        {

            //Most of the cool things would probably be calculated in here or in the Impact method.

            var distance = speed * Time.deltaTime;
            timer += Time.deltaTime;
            longtimer += Time.deltaTime; //i dont feel like doing a bunch of calculations just to have it all in one timer, delta time shits on the modulo too much
            if (timer > 5.9f)
            {
                timer = 0f;
                gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(Assets.rocketFly);
            }
            

            dir = transform.right;

            //var angle = transform.rotation.eulerAngles.z;
            gameObject.GetComponent<Rigidbody2D>().velocity = dir * speed;

            if (longtimer > 30f)
            {
                Destroy(gameObject);
            }

        }
        public void OnCollisionEnter2D(Collision2D collision)
        {
            //ModAPI.Notify("WHY");
            Explode(collision.GetContact(0).point);

        }

        public void Explode(Vector2 pos)
        {
            var expl = ModAPI.CreateParticleEffect("Explosion", pos);
            expl.GetComponent<ExplosionSoundBehviour>().Near = new AudioClip[] { Assets.Explosion };
            ExplosionCreator.CreateFragmentationExplosion(new ExplosionCreator.ExplosionParameters
            {
                Position = pos,
                CreateParticlesAndSound = false,
                EffectSize = ExplosionCreator.EffectSize.Medium,
                DismemberChance = .75f,
                FragmentForce = 12,
                FragmentationRayCount = 32,
                Range = 12f * 8f * ModAPI.PixelSize
            });

            Destroy(gameObject);
        }
        public void Shot(Shot shot)
        {
            Explode(shot.point);
        }
    }
    public class Darkheart : MonoBehaviour, Messages.ILodged
    {

        public void Lodged(Stabbing stabbing)
        {
            for (int i = 0; i < gameObject.GetComponent<PhysicalBehaviour>().penetrations.Capacity; i++)
            {
                var Victim = gameObject.GetComponent<PhysicalBehaviour>().penetrations[i].Victim;
                var limb = Victim.GetComponent<LimbBehaviour>();
                if (limb)
                {
                    limb.BreakingThreshold = 0f;
                    Victim.GetComponent<SpriteRenderer>().color = new Color(.2f, .2f, .2f, 1f);
                    ModAPI.CreateParticleEffect("Disintegration", Victim.gameObject.transform.position);
                }
            }
        }
    }
    public class Windforce : MonoBehaviour, Messages.IDislodged
    {

        public void Dislodged(PhysicalBehaviour.Penetration penetration)
        {
            var rigidbody = penetration.Victim.rigidbody;
            rigidbody.AddForce(gameObject.transform.up * 500);
        }
    }
    public class Illumina : MonoBehaviour, Messages.IUse
    {
        [SkipSerialisation]
        readonly float force = 700f;
        [SkipSerialisation]
        PersonBehaviour holder;
        public void OnGripped(GripBehaviour gripper)
        {
            holder = gripper.gameObject.GetComponent<LimbBehaviour>().Person;
        }
        public void OnDrop()
        {
            holder = null;
        }
        public void Use(ActivationPropagation activation)
        {
            if (holder != null)
            {
                foreach (LimbBehaviour limb in holder.Limbs)
                {
                    var rigidbody = limb.gameObject.GetComponent<Rigidbody2D>();
                    rigidbody.AddForce(gameObject.transform.up * force * limb.gameObject.GetComponent<PhysicalBehaviour>().InitialMass);
                }

            }
            gameObject.GetComponent<Rigidbody2D>().AddForce(gameObject.transform.up * force * gameObject.GetComponent<PhysicalBehaviour>().InitialMass);

        }
    }
    public class Ghostwalker : MonoBehaviour, Messages.ILodged, Messages.IDislodged
    {
        float kills = 0f;
        [SkipSerialisation]
        PersonBehaviour stabbedGuy;
        [SkipSerialisation]
        PersonBehaviour holder;
        public void OnGripped(GripBehaviour gripper)
        {
            holder = gripper.gameObject.GetComponent<LimbBehaviour>().Person;
            foreach (LimbBehaviour limb in holder.Limbs)
            {
                var sprite = limb.gameObject.GetComponent<SpriteRenderer>().color;
                sprite.a = (.2f + ((kills / 9) * .8f));
            }
        }
        public void OnDrop()
        {
            foreach (LimbBehaviour limb in holder.Limbs)
            {
                var sprite = limb.gameObject.GetComponent<SpriteRenderer>().color;
                sprite.a = (.2f + ((kills / 9) * .8f));
            }
            holder = null;
        }

        public void Lodged(Stabbing stabbing)
        {
            var limb = stabbing.victim.gameObject.GetComponent<LimbBehaviour>();
            if (limb)
            {
                if (limb.Person.IsAlive())
                {
                    stabbedGuy = limb.Person;
                }
            }
        }
        public void Dislodged(PhysicalBehaviour.Penetration penetration)
        {
            var limb = penetration.Victim.gameObject.GetComponent<LimbBehaviour>();
            if (limb)
            {
                if (limb.Person == stabbedGuy)
                {
                    if (stabbedGuy.IsAlive() == false)
                    {
                        kills += 1f;
                    }
                }
            }
        }

    }
    public class Firebrand : MonoBehaviour, Messages.ILodged
    {
        [SkipSerialisation]
        PersonBehaviour holder;
        public void OnGripped(GripBehaviour gripper)
        {
            holder = gripper.gameObject.GetComponent<LimbBehaviour>().Person;
            foreach (LimbBehaviour limb in holder.Limbs)
            {
                limb.PhysicalBehaviour.SimulateTemperature = false;
            }
        }
        public void OnDrop()
        {
            foreach (LimbBehaviour limb in holder.Limbs)
            {
                limb.PhysicalBehaviour.SimulateTemperature = true;
            }
            holder = null;
        }

        public void Lodged(Stabbing stabbing)
        {
            for (int i = 0; i < gameObject.GetComponent<PhysicalBehaviour>().penetrations.Capacity; i++)
            {
                var Victim = gameObject.GetComponent<PhysicalBehaviour>().penetrations[i].Victim;
                Victim.Temperature += 450f / Victim.ObjectArea;
            }
        }
    }

    public class IceDagger : MonoBehaviour, Messages.ILodged
    {
        //[SkipSerialisation]
        //bool isDeadly = false;
        //[SkipSerialisation]
        //PersonBehaviour holder;

        //public void Use()
        //{
        //}

        //public void OnGripped(GripBehaviour gripper)
        //{
        //    holder = gripper.gameObject.GetComponent<LimbBehaviour>().Person;
        //    foreach (LimbBehaviour limb in holder.Limbs)
        //    {
        //        limb.PhysicalBehaviour.SimulateTemperature = false;
        //    }
        //}
        //public void OnDrop(GripBehaviour formerGripper)
        //{
        //    foreach (LimbBehaviour limb in holder.Limbs)
        //    {
        //        limb.PhysicalBehaviour.SimulateTemperature = true;
        //    }
        //    holder = null;
        //}

        public void Lodged(Stabbing stabbing)
        {
            for (int i = 0; i < gameObject.GetComponent<PhysicalBehaviour>().penetrations.Capacity; i++)
            {
                var Victim = gameObject.GetComponent<PhysicalBehaviour>().penetrations[i].Victim;
                Victim.Temperature -= 450f / Victim.ObjectArea;
            }
        }
    }
    //public class Venomshank : MonoBehaviour, Messages.ILodged
    //{

    //    public void Lodged(Stabbing stabbing)
    //    {
    //        for (int i = 0; i < gameObject.GetComponent<PhysicalBehaviour>().penetrations.Capacity; i++)
    //        {
    //            var Victim = gameObject.GetComponent<PhysicalBehaviour>().penetrations[i].Victim;
    //            var limb = Victim.GetComponent<LimbBehaviour>();
    //            if (limb)
    //            {
    //                Victim.Temperature += 45f;
    //            }
    //        }
    //    }
    //}
    class Hyperlaser : MonoBehaviour
    {
        [SkipSerialisation]
        readonly float speed = 28;
        [SkipSerialisation]
        public Vector3 dir;
        [SkipSerialisation]
        Vector3 targetDir;
        //[SkipSerialisation]
        //AudioSource audio;
        [SkipSerialisation]
        readonly AudioClip hitSound;
        [SkipSerialisation]
        bool closing;
        [SkipSerialisation]
        float timer;
        [SkipSerialisation]
        Vector3 pos;
        [SkipSerialisation]
        LayerMask layers;

        void Awake()
        {
            var sprite = gameObject.AddComponent<SpriteRenderer>();
            sprite.sprite = Assets.HyperShot;
            ModAPI.CreateLight(transform, Color.cyan, 2, 1);
            //it's a component of a new child GameObject so you can set its local position
            //glow.transform.localPosition = new Vector3(-7.25f * ModAPI.PixelSize, 0, 0);

            //audio = gameObject.AddComponent<AudioSource>();


            layers = LayerMask.GetMask("Objects", "Bounds", "Debris");

            gameObject.SetLayer(LayerMask.NameToLayer("Objects"));
        }

        void Update()
        {

            //Most of the cool things would probably be calculated in here or in the Impact method.

            var distance = speed * Time.deltaTime;
            timer += Time.deltaTime;

            if (timer > 1f)
            {
                closing = true;
            }

            if (closing)
            {
                //trail.autodestruct = true;
                Destroy(gameObject);
                return;
            }

            pos = transform.position;
            dir = transform.right;
            var angle = transform.rotation.eulerAngles.z;

            var ray = Physics2D.BoxCast(pos, new Vector2(15f, 3f) * ModAPI.PixelSize, angle, dir, distance, layers);

            if (ray.collider)
            {
                var hit = ray.collider.gameObject;
                var hitPhys = hit.GetComponent<PhysicalBehaviour>();
                var hitPers = hit.GetComponent<LimbBehaviour>();

                if (hitPhys && hitPhys.ReflectsLasers)
                {
                    var newDir = Vector2.Reflect(transform.right, ray.normal);
                    transform.position = ray.point;
                    transform.right = newDir;
                    return;
                }

                if (hitPhys && hitPhys.AbsorbsLasers)
                {
                    pos += dir * (speed * Time.deltaTime);
                    transform.position = pos;
                    if (hitPers)
                    {
                        Impact(ray);
                        return;
                    }

                }
                else //doesnt use utils.laserhit because it doesnt seem to support circlecast, which usually ignores glass.
                {
                    pos += dir * (speed * Time.deltaTime);
                    transform.position = pos;
                }
            }
            else
            {
                pos += dir * (speed * Time.deltaTime);
                transform.position = pos;
            }
        }
        private void Impact(RaycastHit2D hit)
        {
            //Vector2 normal = hit.normal;
            ModAPI.CreateParticleEffect("BrokenElectronicsSpark", hit.point);
            var person = hit.collider.gameObject.GetComponent<LimbBehaviour>().Person;
            foreach (LimbBehaviour limb in person.Limbs)
            {
                if (limb.gameObject.GetComponent<HyperFade>() == null)
                {
                    //var fade = limb.gameObject.AddComponent<HyperFade>();
                    limb.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();

                }
            }
                var BALLS = new GameObject();
                BALLS.AddComponent<AudioSource>().PlayOneShot(Assets.HyperlaserHit, .06f);
                StartCoroutine(delete());
                IEnumerator delete()
                {
                    yield return new WaitForSeconds(1f);
                    Destroy(BALLS); //balls have been terminated
                }



            //float dir = Mathf.Atan2(normal.y, normal.x);


        }
    }
    class HyperFade : MonoBehaviour
    {
        [SkipSerialisation]
        public Color laserColor; //im gonna add the lame other hyperlasers eventually
        [SkipSerialisation]
        float time = 0f;

        void Awake()
        {
            var outline = gameObject.transform.Find("Outline");
            outline.GetComponent<SpriteRenderer>().enabled = true;
        }
        void Update()
        {
            time += Time.deltaTime;
            if (time > 1)
            {
                Destroy(gameObject);
            }
            var outline = gameObject.transform.Find("Outline");
            outline.GetComponent<SpriteRenderer>().color = new Color(laserColor.r,laserColor.g,laserColor.b,1-time);
        }

    }
    class BlowDryer : CanShoot
    {
        [SkipSerialisation]
        public float Recoil;
        [SkipSerialisation]
        public float InaccuracyMultiplier;
        [SkipSerialisation]
        public float Delay;
        [SkipSerialisation]
        public string[] particles;
        [SkipSerialisation]
        public Type ProjectileType;

        [SkipSerialisation]
        public AudioSource audio;
        [SkipSerialisation]
        public AudioClip clip;

        [SkipSerialisation]
        public Vector2 barrelPosition = new Vector2(0f, 0f);
        [SkipSerialisation]
        public Vector2 barrelDirection = Vector2.right;

        void Awake()
        {
            audio.clip = clip;
        }

        void Use()
        {
            Shoot();
        }
        void UseContinuous()
        {
            Shoot();
        }

        void Update()
        {
            if (gameObject.GetComponent<PhysicalBehaviour>().StoppedBeingUsedContinuously())
            {
                audio.Stop();
            }
        }
        public override void Shoot()
        {

            //audio.pitch = UnityEngine.Random.Range(0.75f, 1.25f); //This is just for variety, it's not required.

            audio.Play();

            var bolt = new GameObject("airbolt", ProjectileType);
            bolt.transform.position = BarrelPosition;
            bolt.transform.right = BarrelDirection + InaccuracyMultiplier * UnityEngine.Random.insideUnitCircle;
            if (transform.localScale.x < 0)
            {
                var lScale = bolt.transform.localScale;
                lScale.x *= -1f;
                bolt.transform.localScale = lScale;
            }

        }

        public override Vector2 BarrelPosition => transform.TransformPoint(barrelPosition);
        public Vector2 BarrelDirection => transform.TransformDirection(barrelDirection) * transform.localScale.x;

    }
    class BlowProjectile : MonoBehaviour
    {
        //[SkipSerialisation]
        //TrailRenderer trail;
        [SkipSerialisation]
        readonly float speed = 10;
        [SkipSerialisation]
        float Timer = 0f;
        [SkipSerialisation]
        public Vector3 dir;
        [SkipSerialisation]
        Vector3 targetDir;
        [SkipSerialisation]
        readonly float damage = 10f / 100f; //limbs dont have 100 health so theres gotta be some adjusting
        [SkipSerialisation]
        readonly float ImpactStrength = 3f;
        //[SkipSerialisation]
        //AudioSource audio;
        //[SkipSerialisation]
        //AudioClip hitSound;
        [SkipSerialisation]
        bool closing;
        [SkipSerialisation]
        Vector3 pos;
        [SkipSerialisation]
        LayerMask layers;
        [SkipSerialisation]
        public bool createHitDecal = true;
        [SkipSerialisation]
        public bool SpawnExplosionEffect = false;

        void Awake()
        {
            gameObject.AddComponent<SpriteRenderer>();
            var randomSprite = gameObject.AddComponent<RandomSpriteBehaviour>();
            randomSprite.sprites = new Sprite[]
                {
                    Assets.bubble1,
                    Assets.bubble2,
                    Assets.bubble3,
                    Assets.bubble4
                };

            //audio = gameObject.AddComponent<AudioSource>();
            //hitSound = Assets.projHit;


            layers = LayerMask.GetMask("Objects", "Bounds", "Debris");

            gameObject.SetLayer(LayerMask.NameToLayer("Objects"));
        }

        void Update()
        {

            //Most of the cool things would probably be calculated in here or in the Impact method.

            var distance = speed * Time.deltaTime;
            Timer += Time.deltaTime;

            if (closing)
            {
                //trail.autodestruct = true;
                Destroy(gameObject);
                return;
            }

            if (Timer > 2f)
            {
                closing = true;
            }

            pos = transform.position;
            dir = transform.right;

            var ray = Physics2D.CircleCast(pos, 6.5f * ModAPI.PixelSize, dir, distance, layers);

            if (ray.collider)
            {
                var hit = ray.collider.gameObject;
                var hitPers = hit.GetComponent<LimbBehaviour>();

                if (hitPers)
                {
                    var limbs = hitPers.Person.Limbs;
                    foreach (LimbBehaviour limb in limbs)
                    {
                        limb.gameObject.GetComponent<Rigidbody2D>().AddForce((gameObject.transform.right * 150) + new Vector3(0f, 60f, 0f) * limb.PhysicalBehaviour.TrueInitialMass);
                    }

                }

                else //doesnt use utils.laserhit because it doesnt seem to support circlecast, which usually ignores glass.
                {
                    pos += dir * (speed * Time.deltaTime);
                    transform.position = pos;
                }
            }
            else
            {
                pos += dir * (speed * Time.deltaTime);
                transform.position = pos;
            }
        }
    }
    class XLSProjectile : MonoBehaviour
    {
        //[SkipSerialisation]
        //TrailRenderer trail;
        [SkipSerialisation]
        readonly float speed = 45;
        [SkipSerialisation]
        public Vector3 dir;
        [SkipSerialisation]
        readonly float damage = 10f; //limbs dont have 100 health so theres gotta be some adjusting
        [SkipSerialisation]
        readonly float ImpactStrength = 3f;
        //[SkipSerialisation]
        //AudioSource audio;
        //[SkipSerialisation]
        //AudioClip hitSound;
        [SkipSerialisation]
        bool closing;
        [SkipSerialisation]
        Vector3 pos;
        [SkipSerialisation]
        LayerMask layers;
        [SkipSerialisation]
        public bool createHitDecal = true;
        [SkipSerialisation]
        public bool SpawnExplosionEffect = false;

        void Awake()
        {
            var sprite = gameObject.AddComponent<SpriteRenderer>();
            sprite.sprite = Assets.XLSbullet;

            //audio = gameObject.AddComponent<AudioSource>();
            //hitSound = Assets.projHit;


            layers = LayerMask.GetMask("Objects", "Bounds", "Debris");

            gameObject.SetLayer(LayerMask.NameToLayer("Objects"));
        }

        void Update()
        {

            //Most of the cool things would probably be calculated in here or in the Impact method.

            var distance = speed * Time.deltaTime;

            if (closing)
            {
                //trail.autodestruct = true;
                Destroy(gameObject);
                return;
            }

            pos = transform.position;
            dir = transform.right;

            var ray = Physics2D.CircleCast(pos, 3f * ModAPI.PixelSize, dir, distance, layers);

            if (ray.collider)
            {
                var hit = ray.collider.gameObject;
                var hitPhys = hit.GetComponent<PhysicalBehaviour>();

                if (hitPhys && hitPhys.ReflectsLasers)
                {
                    hitPhys.rigidbody.AddForceAtPosition(ray.normal * -ImpactStrength, ray.point, ForceMode2D.Impulse);
                    var newDir = Vector2.Reflect(transform.right, ray.normal);
                    transform.position = ray.point;
                    transform.right = newDir;
                    return;
                }

                if (hitPhys && hitPhys.AbsorbsLasers)
                {
                    pos += dir * (speed * Time.deltaTime);
                    transform.position = pos;
                    transform.position = ray.point;
                    ray.collider.attachedRigidbody.AddForceAtPosition(ray.normal * -ImpactStrength, ray.point);
                    Impact(ray);
                    return;
                }
                else //doesnt use utils.laserhit because it doesnt seem to support circlecast, which usually ignores glass.
                {
                    pos += dir * (speed * Time.deltaTime);
                    transform.position = pos;
                }
            }
            else
            {
                pos += dir * (speed * Time.deltaTime);
                transform.position = pos;
            }
        }
        private void Impact(RaycastHit2D hit)
        {
            Vector2 normal = hit.normal;
            hit.transform.SendMessage("Shot", new Shot(normal, hit.point, this.damage, true), SendMessageOptions.DontRequireReceiver);
            this.closing = true;

            //float dir = Mathf.Atan2(normal.y, normal.x);
        }
    }
    class ShooterBehaviour : CanShoot
    {
        [SkipSerialisation]
        public float Recoil;
        [SkipSerialisation]
        public float InaccuracyMultiplier;
        [SkipSerialisation]
        public float Delay;
        [SkipSerialisation]
        public string[] particles;
        [SkipSerialisation]
        public Type ProjectileType;

        //[SkipSerialisation]
        //public AudioSource audio;
        [SkipSerialisation]
        public AudioClip[] clips;

        [SkipSerialisation]
        public Vector2 barrelPosition = new Vector2(0f, 0f);
        [SkipSerialisation]
        public Vector2 barrelDirection = Vector2.right;
        [SkipSerialisation]
        float t = 0f;
        [SkipSerialisation]
        public float reloadTime = 0f;

        void Use()
        {
            Shoot();
        }


        void UseContinuous()

        {
            if (t > Delay)
            {
                Shoot();
            }
        }

        void Update()
        {
            t += Time.deltaTime;
        }

        public override void Shoot()
        {

            //audio.pitch = UnityEngine.Random.Range(0.75f, 1.25f); //This is just for variety, it's not required.
            if (clips.Length > 0)
            {
                gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(clips[0]);
            }
            t = 0f;
            GetComponent<PhysicalBehaviour>().rigidbody.AddForceAtPosition(BarrelDirection * -this.Recoil, BarrelPosition, ForceMode2D.Impulse);

            var bolt = new GameObject("bolt", ProjectileType);
            bolt.transform.position = BarrelPosition;
            bolt.transform.right = BarrelDirection + InaccuracyMultiplier * UnityEngine.Random.insideUnitCircle;
            if (transform.localScale.x < 0)
            {
                var lScale = bolt.transform.localScale;
                lScale.x *= -1f;
                bolt.transform.localScale = lScale;
            }
            else
            {
            }

            for (int i = 0; i < particles.Length; i++)
            {
                ModAPI.CreateParticleEffect(particles[i], BarrelPosition);
            }
            if (reloadTime > 0f)
            {
                StartCoroutine(reload()); //for things that make a reload sound.
                IEnumerator reload()
                {
                    yield return new WaitForSeconds(reloadTime);
                    gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(clips[1]);
                }

            }
        }

        public override Vector2 BarrelPosition => transform.TransformPoint(barrelPosition);
        public Vector2 BarrelDirection => transform.TransformDirection(barrelDirection) * transform.localScale.x;

    }
    public class R80 : MonoBehaviour, Messages.IUse
    {
        //[SkipSerialisation]
        //public AudioSource AS;
        [SkipSerialisation]
        public AudioClip fuse;
        [SkipSerialisation]
        public bool debounce = false;
        public void Use(ActivationPropagation activation)
        {


            //AudioSource AS = gameObject.GetComponent<AudioSource>();
            StartCoroutine(FUSE());
            IEnumerator FUSE()
            {
                if (!(debounce))
                {
                    debounce = true;
                    gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(fuse);
                    for (int i = 0; i < 50; i++)
                    {
                        ModAPI.CreateParticleEffect("Flash", transform.position);//spark, flash
                        yield return new WaitForSeconds(.1f);
                    }
                    for (int i = 0; i < 3; i++)
                    {
                        var expl = ModAPI.CreateParticleEffect("Explosion", transform.position);
                        expl.GetComponent<ExplosionSoundBehviour>().Near = new AudioClip[] { Assets.R80Explosion };
                        ExplosionCreator.CreateFragmentationExplosion(new ExplosionCreator.ExplosionParameters
                        {
                            Position = UnityEngine.Random.insideUnitSphere + gameObject.transform.position,
                            CreateParticlesAndSound = false,
                            EffectSize = ExplosionCreator.EffectSize.Medium,
                            DismemberChance = .75f,
                            FragmentForce = 12,
                            FragmentationRayCount = 32,
                            Range = 12f * 12f * ModAPI.PixelSize
                        });
                        yield return new WaitForSeconds(.05f);
                    }
                    Destroy(gameObject);
                }

            }
        }

    }

    public class FuseBomb : MonoBehaviour, Messages.IUse
    {
        //var AS = gameObject.GetComponent<AudioSource>();
        //AudioSource AS;
        //[SkipSerialisation]
        //public AudioSource AS;
        [SkipSerialisation]
        public AudioClip fuse;
        [SkipSerialisation]
        public bool debounce = false;
        //public AudioClip explode;

        //void Start()
        //{
        //    AS = gameObject.GetComponent<AudioSource>();
        //}
        public void Use(ActivationPropagation activation)
        {
            var update = .4f;
            //AudioSource AS = gameObject.GetComponent<AudioSource>();
            StartCoroutine(FUSE());
            IEnumerator FUSE()
            {
                if (!(debounce))
                {
                    debounce = true;
                    while (update > .1f)
                    {
                        gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(fuse);
                        ModAPI.CreateParticleEffect("Flash", transform.position);//spark, flash
                        yield return new WaitForSeconds(update);
                        update *= .9f;
                    }
                    var expl = ModAPI.CreateParticleEffect("Explosion", transform.position);
                    expl.GetComponent<ExplosionSoundBehviour>().Near = new AudioClip[] { Assets.R80Explosion };
                    ExplosionCreator.CreateFragmentationExplosion(new ExplosionCreator.ExplosionParameters
                    {
                        Position = gameObject.transform.position,
                        CreateParticlesAndSound = false,
                        EffectSize = ExplosionCreator.EffectSize.Medium,
                        DismemberChance = .5f,
                        FragmentForce = 12,
                        FragmentationRayCount = 32,
                        Range = 12f * 12f * ModAPI.PixelSize
                    });
                    Destroy(gameObject);
                }

                //var emit = new GameObject("BombParticles");
                //var particle = emit.AddComponent<ParticleSystem>();
                //particle.Material = ModAPI.FindMaterial("VeryBright");
                //particle.shapeType = ParticleSystemShapeType.Circle;

                //yield return new WaitForSeconds(5);
                //AS.PlayOneShot(explode);
            }

        }

    }

    public class LiftBehaviour : MonoBehaviour, Messages.IOnGripped, Messages.IOnDrop
    {

        public void OnGripped(GripBehaviour gripper)
        {
            gameObject.GetComponent<PhysicalBehaviour>().MakeWeightless();
        }

        public void OnDrop(GripBehaviour formerGripper)
        {
            gameObject.GetComponent<PhysicalBehaviour>().MakeWeightful();
        }
    }
    public class Peel : MonoBehaviour, Messages.IOnGripped, Messages.IOnDrop
    {
        [SkipSerialisation]
        public AudioClip place;
        [SkipSerialisation]
        public AudioClip slip;
        //[SkipSerialisation]
        //public AudioSource AS;
        [SkipSerialisation]
        public bool active = true;

        public void OnCollisionEnter2D(Collision2D collision)
        {
            var person = collision.gameObject.GetComponent<LimbBehaviour>().Person;

            if (person)
            {
                if (active)
                {
                    gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(slip, .8f);
                    var con = person.Consciousness;
                    if (person.Consciousness > .8f)
                    {
                        StartCoroutine(trip());
                        IEnumerator trip()
                        {
                            person.Consciousness = 0f;
                            yield return new WaitForSeconds(.9f);
                            person.Consciousness = con;
                        }
                    }
                }
            }
        }
        public void OnGripped(GripBehaviour gripper)
        {
            active = false;
        }
        public void OnDrop(GripBehaviour formerGripper)
        {
            //AudioSource AS = gameObject.GetComponent<AudioSource>();
            StartCoroutine(activate());
            IEnumerator activate()
            {
                yield return new WaitForSeconds(.5f);
                active = true;
                gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(place);
            }
        }
    }

    public class Witched : MonoBehaviour
    {
        void Start()
        {
            StartCoroutine(Piss());
        }

        public IEnumerator Piss()
        {
            gameObject.GetComponent<SpriteRenderer>().color = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value);
            for (int i = 0; i < 10; i++)
            {
                yield return new WaitForSeconds(.1f);
                gameObject.transform.localScale *= 1.05f;
            }
            yield return new WaitForSeconds(12f);
            for (int i = 0; i < 10; i++)
            {
                yield return new WaitForSeconds(.1f);
                gameObject.transform.localScale /= 1.05f;
            }
            gameObject.GetComponent<SpriteRenderer>().color = Color.white;
            Destroy(this);
        }
    }
    public class WitchesBrew : MonoBehaviour, Messages.IUse
    {
        [SkipSerialisation]
        public AudioClip useSound;
        //[SkipSerialisation]
        //public AudioSource AudioPlayer;
        [SkipSerialisation]
        public bool isFood; //if its not a food its likely a drink, which can only be consumed by the top
        [SkipSerialisation]
        public float distance = 9f;
        [SkipSerialisation]
        public float delay = 3f;
        [SkipSerialisation]
        public bool debounce = false;
        [SkipSerialisation]
        public float healamount = 0f; //out of 100

        public void Use(ActivationPropagation activation)
        {
            if (!debounce)
            {
                var ray = Utils.MaterialAwareRaycast(gameObject.transform.position, gameObject.transform.up, distance * ModAPI.PixelSize, LayerMask.GetMask("Objects", "Bounds", "Debris"), 16);
                if (ray.hit.HasValue)
                {
                    var limb = ray.hit.Value.collider.gameObject.GetComponent<LimbBehaviour>();
                    if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
                    {
                        gameObject.GetComponent<PhysicalBehaviour>().PlayClipOnce(useSound);
                        debounce = true;
                        StartCoroutine(reload());
                        IEnumerator reload()
                        {
                            yield return new WaitForSeconds(delay);
                            if (!(limb.gameObject.GetComponent<Witched>()))
                            {
                                limb.gameObject.AddComponent<Witched>();
                            }
                            debounce = false;

                        }
                    }

                }
            }

        }
    }

    //public class DancePotion : MonoBehaviour, Messages.IUse
    //{
    //    [SkipSerialisation]
    //    public AudioClip useSound;
    //    [SkipSerialisation]
    //    public AudioSource AudioPlayer;
    //    [SkipSerialisation]
    //    public String Dance;
    //    [SkipSerialisation]
    //    public float distance = 9f;
    //    [SkipSerialisation]
    //    public bool debounce = false;

    //    public void Use(ActivationPropagation activation)
    //    {
    //        if (!debounce)
    //        {
    //            var ray = Utils.MaterialAwareRaycast(gameObject.transform.position, gameObject.transform.up, distance * ModAPI.PixelSize, LayerMask.GetMask("Objects", "Bounds", "Debris"), 16);
    //            if (ray.hit.HasValue)
    //            {
    //                var limb = ray.hit.Value.collider.gameObject.GetComponent<LimbBehaviour>();
    //                if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
    //                {
    //                    AudioPlayer.PlayOneShot(useSound);
    //                    debounce = true;
    //                    StartCoroutine(reload());
    //                    IEnumerator reload()
    //                    {
    //                        yield return new WaitForSeconds(.05f);
    //                        if (!(limb.gameObject.transform.parent.gameObject.GetComponent<DanceTime>()))
    //                        {
    //                            var DT = limb.gameObject.transform.parent.gameObject.AddComponent<DanceTime>();
    //                            DT.Dance = "Monster Mash";
    //                        }
    //                        debounce = false;

    //                    }
    //                }
    //            }
    //        }
    //    }
    //}

    //public class DanceTime : MonoBehaviour
    //{
    //    public String Dance;
    //    void Start()
    //    {
    //        if (Dance == "Monster Mash")
    //        {
    //            StartCoroutine(MonsterMash());
    //        }
    //    }

    //    public IEnumerator MonsterMash()
    //    {
    //        var RDP = new RagdollPose();
    //        RDP.Name = "Monster Mash";
    //        RDP.Angles = new RagdollPose.LimbPose[]
    //        {
    //            new RagdollPose.LimbPose()
    //            {
    //                Name = "MM_UpperArm_Front",
    //                Limb = gameObject.transform.Find("FrontArm").Find("UpperArmFront").gameObject.GetComponent<LimbBehaviour>(),
    //            },
    //        }`1

    //        yield return new WaitForSeconds(.1f);
    //        Destroy(this);
    //    }
    //}
    public class SimpleEdibleBehaviour : MonoBehaviour, Messages.IUse
    {
        [SkipSerialisation]
        public AudioClip useSound;
        [SkipSerialisation]
        private PhysicalBehaviour phys;
        [SkipSerialisation]
        public bool isFood; //if its not a food its likely a drink, which can only be consumed by the top
        [SkipSerialisation]
        public float distance = 9f;
        [SkipSerialisation]
        public float delay = 3f;
        [SkipSerialisation]
        public bool debounce = false;
        [SkipSerialisation]
        public float healamount = 5f; //out of 100

        void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
        }

        public void Use(ActivationPropagation activation)
        {
            if (!debounce)
            {
                if (isFood)
                {
                    var ray = Physics2D.OverlapCircleAll(transform.position, distance * ModAPI.PixelSize, LayerMask.GetMask("Objects", "Bounds", "Debris"));
                    foreach (Collider2D collider in ray)
                    {
                        if (collider)
                        {
                            var limb = collider.gameObject.GetComponent<LimbBehaviour>();
                            if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
                            {
                                phys.PlayClipOnce(useSound);
                                foreach (LimbBehaviour part in limb.Person.Limbs)
                                {
                                    if (part.Health <= part.InitialHealth)
                                    {
                                        part.Health += part.InitialHealth / (100 / healamount);
                                    }
                                }
                                debounce = true;
                                StartCoroutine(reload());

                            }
                        }
                    }
                }
                else
                {
                    var ray = Utils.MaterialAwareRaycast(gameObject.transform.position, gameObject.transform.up, distance * ModAPI.PixelSize, LayerMask.GetMask("Objects", "Bounds", "Debris"), 16);
                    if (ray.hit.HasValue)
                    {
                        var limb = ray.hit.Value.collider.gameObject.GetComponent<LimbBehaviour>();
                        if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
                        {
                            phys.PlayClipOnce(useSound);
                            foreach (LimbBehaviour part in limb.Person.Limbs)
                            {
                                if (part.Health <= part.InitialHealth)
                                {
                                    part.Health += part.InitialHealth / (100 / healamount);
                                }
                            }
                            debounce = true;
                            StartCoroutine(reload());
                        }

                    }
                }
                IEnumerator reload()
                {
                    yield return new WaitForSeconds(delay);
                    debounce = false;
                }
            }
        }
    }
    public class HasBeenSpawned : MonoBehaviour
    {

    }
    #endregion
    #region behaviours2
    public class MultiAvatar : MonoBehaviour //im proud of this but someone else has already done it before
    {
        [SkipSerialisation]
        public Texture2D[] skins;
        [SkipSerialisation]
        public Texture2D flesh;
        [SkipSerialisation]
        public Texture2D bone;
        [SkipSerialisation]
        public Sprite[] hats;
        [SkipSerialisation]
        private PersonBehaviour pers;
        [SkipSerialisation]
        public GameObject[] accesories;
        public int SelectedSkin;
        public bool isRandom;

        void Start()
        {
            //ModAPI.Notify(pers);
            ChangeAvatar();

            foreach (LimbBehaviour limb in pers.Limbs)
            {
                limb.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("NextSkin", "Next Avatar", "Changes the person to their next avatar.", () =>
                {
                    SelectedSkin += 1;
                    if (SelectedSkin >= skins.Length)
                    {
                        SelectedSkin = 0;
                    }
                    ChangeAvatar();

                }
                ));
            }
        }
        void Awake()
        {
            pers = gameObject.GetComponent<PersonBehaviour>();
        }

        void ChangeAvatar()
        {
            //ModAPI.Notify(skins[SelectedSkin]);
            pers.SetBodyTextures(skins[SelectedSkin], flesh, bone, 1);
            //ModAPI.Notify("balls1");
            if (accesories.Length >= 1)
            {
                int i = 0;
                foreach (GameObject hat in accesories)
                {
                    hat.GetComponent<SpriteRenderer>().sprite = hats[SelectedSkin + i];
                    i += 1;
                }
            }
            else
            {
                accesories[0].GetComponent<SpriteRenderer>().sprite = hats[SelectedSkin];
            }
        }
    }

    public class RotHat : MonoBehaviour //idk if anyones ever done this before but i proud of this it make me happy
    {
        [SkipSerialisation]
        SkinMaterialHandler headM;
        [SkipSerialisation]
        SpriteRenderer hatS;
        [SkipSerialisation]
        private float oldProg = 0f;
        [SkipSerialisation]
        private Color rottenColor;

        void Awake()
        {
            headM = gameObject.transform.parent.gameObject.GetComponent<SkinMaterialHandler>();
            hatS = gameObject.GetComponent<SpriteRenderer>();
            rottenColor = new Color(Assets.zColor.x / 255f, Assets.zColor.y / 255f, Assets.zColor.z / 255f);
            headM.renderer.material.SetColor("_Zombie", rottenColor);
        }
        void Update()
        {
            if (headM.RottenProgress != oldProg)
            {
                hatS.material.SetFloat(ShaderProperties.Get("_RottenProgress"), headM.RottenProgress);
                hatS.color = (new Color(1f - headM.RottenProgress, 1f - headM.RottenProgress, 1f - headM.RottenProgress)) + (rottenColor * headM.RottenProgress);
               //ModAPI.Notify(headM.RottenProgress);
               oldProg = headM.RottenProgress;
            }
        }
    }
    #endregion

#pragma warning restore IDE0051 // Remove unused private members
}
// Originally uploaded by 'hankmart'. Do not reupload without their explicit permission.
